



#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>


#define TOTAL_CROSS  0x01
#define PRIM_CROSS   0x02
#define NUCL_CROSS   0x04
#define INTER_CROSS   0x08


typedef struct {
	float theta;
	float total;
	float prim;
	float nucl;
	float inter;
}cross_table_t;

typedef struct {
	float E;
	cross_table_t *t;
}cross_table_ptr_t;

#define NUM_ETA_TABLES 72
#define NUM_ETA_TABLE_ENTRIES 344

extern cross_table_ptr_t eta_cross_He4[72];
extern cross_table_ptr_t eta_cross_C12[72];
extern cross_table_ptr_t eta_prime_cross_C12[72];
extern cross_table_ptr_t eta_prime_cross_He4[72];



extern cross_table_t eta_He4_E10_0[344];
extern cross_table_t eta_He4_E10_1[344];
extern cross_table_t eta_He4_E10_2[344];
extern cross_table_t eta_He4_E10_3[344];
extern cross_table_t eta_He4_E10_4[344];
extern cross_table_t eta_He4_E10_5[344];
extern cross_table_t eta_He4_E10_6[344];
extern cross_table_t eta_He4_E10_7[344];
extern cross_table_t eta_He4_E10_8[344];
extern cross_table_t eta_He4_E10_9[344];
extern cross_table_t eta_He4_E11_0[344];
extern cross_table_t eta_He4_E11_1[344];
extern cross_table_t eta_He4_E4_0[344];
extern cross_table_t eta_He4_E4_1[344];
extern cross_table_t eta_He4_E4_2[344];
extern cross_table_t eta_He4_E4_3[344];
extern cross_table_t eta_He4_E4_4[344];
extern cross_table_t eta_He4_E4_5[344];
extern cross_table_t eta_He4_E4_6[344];
extern cross_table_t eta_He4_E4_7[344];
extern cross_table_t eta_He4_E4_8[344];
extern cross_table_t eta_He4_E4_9[344];
extern cross_table_t eta_He4_E5_0[344];
extern cross_table_t eta_He4_E5_1[344];
extern cross_table_t eta_He4_E5_2[344];
extern cross_table_t eta_He4_E5_3[344];
extern cross_table_t eta_He4_E5_4[344];
extern cross_table_t eta_He4_E5_5[344];
extern cross_table_t eta_He4_E5_6[344];
extern cross_table_t eta_He4_E5_7[344];
extern cross_table_t eta_He4_E5_8[344];
extern cross_table_t eta_He4_E5_9[344];
extern cross_table_t eta_He4_E6_0[344];
extern cross_table_t eta_He4_E6_1[344];
extern cross_table_t eta_He4_E6_2[344];
extern cross_table_t eta_He4_E6_3[344];
extern cross_table_t eta_He4_E6_4[344];
extern cross_table_t eta_He4_E6_5[344];
extern cross_table_t eta_He4_E6_6[344];
extern cross_table_t eta_He4_E6_7[344];
extern cross_table_t eta_He4_E6_8[344];
extern cross_table_t eta_He4_E6_9[344];
extern cross_table_t eta_He4_E7_0[344];
extern cross_table_t eta_He4_E7_1[344];
extern cross_table_t eta_He4_E7_2[344];
extern cross_table_t eta_He4_E7_3[344];
extern cross_table_t eta_He4_E7_4[344];
extern cross_table_t eta_He4_E7_5[344];
extern cross_table_t eta_He4_E7_6[344];
extern cross_table_t eta_He4_E7_7[344];
extern cross_table_t eta_He4_E7_8[344];
extern cross_table_t eta_He4_E7_9[344];
extern cross_table_t eta_He4_E8_0[344];
extern cross_table_t eta_He4_E8_1[344];
extern cross_table_t eta_He4_E8_2[344];
extern cross_table_t eta_He4_E8_3[344];
extern cross_table_t eta_He4_E8_4[344];
extern cross_table_t eta_He4_E8_5[344];
extern cross_table_t eta_He4_E8_6[344];
extern cross_table_t eta_He4_E8_7[344];
extern cross_table_t eta_He4_E8_8[344];
extern cross_table_t eta_He4_E8_9[344];
extern cross_table_t eta_He4_E9_0[344];
extern cross_table_t eta_He4_E9_1[344];
extern cross_table_t eta_He4_E9_2[344];
extern cross_table_t eta_He4_E9_3[344];
extern cross_table_t eta_He4_E9_4[344];
extern cross_table_t eta_He4_E9_5[344];
extern cross_table_t eta_He4_E9_6[344];
extern cross_table_t eta_He4_E9_7[344];
extern cross_table_t eta_He4_E9_8[344];
extern cross_table_t eta_He4_E9_9[344];

extern cross_table_t eta_C12_E4_0[344];
extern cross_table_t eta_C12_E4_1[344];
extern cross_table_t eta_C12_E4_2[344];
extern cross_table_t eta_C12_E4_3[344];
extern cross_table_t eta_C12_E4_4[344];
extern cross_table_t eta_C12_E4_5[344];
extern cross_table_t eta_C12_E4_6[344];
extern cross_table_t eta_C12_E4_7[344];
extern cross_table_t eta_C12_E4_8[344];
extern cross_table_t eta_C12_E4_9[344];
extern cross_table_t eta_C12_E5_0[344];
extern cross_table_t eta_C12_E5_1[344];
extern cross_table_t eta_C12_E5_2[344];
extern cross_table_t eta_C12_E5_3[344];
extern cross_table_t eta_C12_E5_4[344];
extern cross_table_t eta_C12_E5_5[344];
extern cross_table_t eta_C12_E5_6[344];
extern cross_table_t eta_C12_E5_7[344];
extern cross_table_t eta_C12_E5_8[344];
extern cross_table_t eta_C12_E5_9[344];
extern cross_table_t eta_C12_E6_0[344];
extern cross_table_t eta_C12_E6_1[344];
extern cross_table_t eta_C12_E6_2[344];
extern cross_table_t eta_C12_E6_3[344];
extern cross_table_t eta_C12_E6_4[344];
extern cross_table_t eta_C12_E6_5[344];
extern cross_table_t eta_C12_E6_6[344];
extern cross_table_t eta_C12_E6_7[344];
extern cross_table_t eta_C12_E6_8[344];
extern cross_table_t eta_C12_E6_9[344];
extern cross_table_t eta_C12_E7_0[344];
extern cross_table_t eta_C12_E7_1[344];
extern cross_table_t eta_C12_E7_2[344];
extern cross_table_t eta_C12_E7_3[344];
extern cross_table_t eta_C12_E7_4[344];
extern cross_table_t eta_C12_E7_5[344];
extern cross_table_t eta_C12_E7_6[344];
extern cross_table_t eta_C12_E7_7[344];
extern cross_table_t eta_C12_E7_8[344];
extern cross_table_t eta_C12_E7_9[344];
extern cross_table_t eta_C12_E8_0[344];
extern cross_table_t eta_C12_E8_1[344];
extern cross_table_t eta_C12_E8_2[344];
extern cross_table_t eta_C12_E8_3[344];
extern cross_table_t eta_C12_E8_4[344];
extern cross_table_t eta_C12_E8_5[344];
extern cross_table_t eta_C12_E8_6[344];
extern cross_table_t eta_C12_E8_7[344];
extern cross_table_t eta_C12_E8_8[344];
extern cross_table_t eta_C12_E8_9[344];
extern cross_table_t eta_C12_E9_0[344];
extern cross_table_t eta_C12_E9_1[344];
extern cross_table_t eta_C12_E9_2[344];
extern cross_table_t eta_C12_E9_3[344];
extern cross_table_t eta_C12_E9_4[344];
extern cross_table_t eta_C12_E9_5[344];
extern cross_table_t eta_C12_E9_6[344];
extern cross_table_t eta_C12_E9_7[344];
extern cross_table_t eta_C12_E9_8[344];
extern cross_table_t eta_C12_E9_9[344];
extern cross_table_t eta_C12_E10_0[344];
extern cross_table_t eta_C12_E10_1[344];
extern cross_table_t eta_C12_E10_2[344];
extern cross_table_t eta_C12_E10_3[344];
extern cross_table_t eta_C12_E10_4[344];
extern cross_table_t eta_C12_E10_5[344];
extern cross_table_t eta_C12_E10_6[344];
extern cross_table_t eta_C12_E10_7[344];
extern cross_table_t eta_C12_E10_8[344];
extern cross_table_t eta_C12_E10_9[344];
extern cross_table_t eta_C12_E11_0[344];
extern cross_table_t eta_C12_E11_1[344];

extern cross_table_t eta_prime_C12_E4_0[344];
extern cross_table_t eta_prime_C12_E4_1[344];
extern cross_table_t eta_prime_C12_E4_2[344];
extern cross_table_t eta_prime_C12_E4_3[344];
extern cross_table_t eta_prime_C12_E4_4[344];
extern cross_table_t eta_prime_C12_E4_5[344];
extern cross_table_t eta_prime_C12_E4_6[344];
extern cross_table_t eta_prime_C12_E4_7[344];
extern cross_table_t eta_prime_C12_E4_8[344];
extern cross_table_t eta_prime_C12_E4_9[344];
extern cross_table_t eta_prime_C12_E5_0[344];
extern cross_table_t eta_prime_C12_E5_1[344];
extern cross_table_t eta_prime_C12_E5_2[344];
extern cross_table_t eta_prime_C12_E5_3[344];
extern cross_table_t eta_prime_C12_E5_4[344];
extern cross_table_t eta_prime_C12_E5_5[344];
extern cross_table_t eta_prime_C12_E5_6[344];
extern cross_table_t eta_prime_C12_E5_7[344];
extern cross_table_t eta_prime_C12_E5_8[344];
extern cross_table_t eta_prime_C12_E5_9[344];
extern cross_table_t eta_prime_C12_E6_0[344];
extern cross_table_t eta_prime_C12_E6_1[344];
extern cross_table_t eta_prime_C12_E6_2[344];
extern cross_table_t eta_prime_C12_E6_3[344];
extern cross_table_t eta_prime_C12_E6_4[344];
extern cross_table_t eta_prime_C12_E6_5[344];
extern cross_table_t eta_prime_C12_E6_6[344];
extern cross_table_t eta_prime_C12_E6_7[344];
extern cross_table_t eta_prime_C12_E6_8[344];
extern cross_table_t eta_prime_C12_E6_9[344];
extern cross_table_t eta_prime_C12_E7_0[344];
extern cross_table_t eta_prime_C12_E7_1[344];
extern cross_table_t eta_prime_C12_E7_2[344];
extern cross_table_t eta_prime_C12_E7_3[344];
extern cross_table_t eta_prime_C12_E7_4[344];
extern cross_table_t eta_prime_C12_E7_5[344];
extern cross_table_t eta_prime_C12_E7_6[344];
extern cross_table_t eta_prime_C12_E7_7[344];
extern cross_table_t eta_prime_C12_E7_8[344];
extern cross_table_t eta_prime_C12_E7_9[344];
extern cross_table_t eta_prime_C12_E8_0[344];
extern cross_table_t eta_prime_C12_E8_1[344];
extern cross_table_t eta_prime_C12_E8_2[344];
extern cross_table_t eta_prime_C12_E8_3[344];
extern cross_table_t eta_prime_C12_E8_4[344];
extern cross_table_t eta_prime_C12_E8_5[344];
extern cross_table_t eta_prime_C12_E8_6[344];
extern cross_table_t eta_prime_C12_E8_7[344];
extern cross_table_t eta_prime_C12_E8_8[344];
extern cross_table_t eta_prime_C12_E8_9[344];
extern cross_table_t eta_prime_C12_E9_0[344];
extern cross_table_t eta_prime_C12_E9_1[344];
extern cross_table_t eta_prime_C12_E9_2[344];
extern cross_table_t eta_prime_C12_E9_3[344];
extern cross_table_t eta_prime_C12_E9_4[344];
extern cross_table_t eta_prime_C12_E9_5[344];
extern cross_table_t eta_prime_C12_E9_6[344];
extern cross_table_t eta_prime_C12_E9_7[344];
extern cross_table_t eta_prime_C12_E9_8[344];
extern cross_table_t eta_prime_C12_E9_9[344];
extern cross_table_t eta_prime_C12_E10_0[344];
extern cross_table_t eta_prime_C12_E10_1[344];
extern cross_table_t eta_prime_C12_E10_2[344];
extern cross_table_t eta_prime_C12_E10_3[344];
extern cross_table_t eta_prime_C12_E10_4[344];
extern cross_table_t eta_prime_C12_E10_5[344];
extern cross_table_t eta_prime_C12_E10_6[344];
extern cross_table_t eta_prime_C12_E10_7[344];
extern cross_table_t eta_prime_C12_E10_8[344];
extern cross_table_t eta_prime_C12_E10_9[344];
extern cross_table_t eta_prime_C12_E11_0[344];
extern cross_table_t eta_prime_C12_E11_1[344];

extern cross_table_t eta_prime_He4_E4_0[344];
extern cross_table_t eta_prime_He4_E4_1[344];
extern cross_table_t eta_prime_He4_E4_2[344];
extern cross_table_t eta_prime_He4_E4_3[344];
extern cross_table_t eta_prime_He4_E4_4[344];
extern cross_table_t eta_prime_He4_E4_5[344];
extern cross_table_t eta_prime_He4_E4_6[344];
extern cross_table_t eta_prime_He4_E4_7[344];
extern cross_table_t eta_prime_He4_E4_8[344];
extern cross_table_t eta_prime_He4_E4_9[344];
extern cross_table_t eta_prime_He4_E5_0[344];
extern cross_table_t eta_prime_He4_E5_1[344];
extern cross_table_t eta_prime_He4_E5_2[344];
extern cross_table_t eta_prime_He4_E5_3[344];
extern cross_table_t eta_prime_He4_E5_4[344];
extern cross_table_t eta_prime_He4_E5_5[344];
extern cross_table_t eta_prime_He4_E5_6[344];
extern cross_table_t eta_prime_He4_E5_7[344];
extern cross_table_t eta_prime_He4_E5_8[344];
extern cross_table_t eta_prime_He4_E5_9[344];
extern cross_table_t eta_prime_He4_E6_0[344];
extern cross_table_t eta_prime_He4_E6_1[344];
extern cross_table_t eta_prime_He4_E6_2[344];
extern cross_table_t eta_prime_He4_E6_3[344];
extern cross_table_t eta_prime_He4_E6_4[344];
extern cross_table_t eta_prime_He4_E6_5[344];
extern cross_table_t eta_prime_He4_E6_6[344];
extern cross_table_t eta_prime_He4_E6_7[344];
extern cross_table_t eta_prime_He4_E6_8[344];
extern cross_table_t eta_prime_He4_E6_9[344];
extern cross_table_t eta_prime_He4_E7_0[344];
extern cross_table_t eta_prime_He4_E7_1[344];
extern cross_table_t eta_prime_He4_E7_2[344];
extern cross_table_t eta_prime_He4_E7_3[344];
extern cross_table_t eta_prime_He4_E7_4[344];
extern cross_table_t eta_prime_He4_E7_5[344];
extern cross_table_t eta_prime_He4_E7_6[344];
extern cross_table_t eta_prime_He4_E7_7[344];
extern cross_table_t eta_prime_He4_E7_8[344];
extern cross_table_t eta_prime_He4_E7_9[344];
extern cross_table_t eta_prime_He4_E8_0[344];
extern cross_table_t eta_prime_He4_E8_1[344];
extern cross_table_t eta_prime_He4_E8_2[344];
extern cross_table_t eta_prime_He4_E8_3[344];
extern cross_table_t eta_prime_He4_E8_4[344];
extern cross_table_t eta_prime_He4_E8_5[344];
extern cross_table_t eta_prime_He4_E8_6[344];
extern cross_table_t eta_prime_He4_E8_7[344];
extern cross_table_t eta_prime_He4_E8_8[344];
extern cross_table_t eta_prime_He4_E8_9[344];
extern cross_table_t eta_prime_He4_E9_0[344];
extern cross_table_t eta_prime_He4_E9_1[344];
extern cross_table_t eta_prime_He4_E9_2[344];
extern cross_table_t eta_prime_He4_E9_3[344];
extern cross_table_t eta_prime_He4_E9_4[344];
extern cross_table_t eta_prime_He4_E9_5[344];
extern cross_table_t eta_prime_He4_E9_6[344];
extern cross_table_t eta_prime_He4_E9_7[344];
extern cross_table_t eta_prime_He4_E9_8[344];
extern cross_table_t eta_prime_He4_E9_9[344];
extern cross_table_t eta_prime_He4_E10_0[344];
extern cross_table_t eta_prime_He4_E10_1[344];
extern cross_table_t eta_prime_He4_E10_2[344];
extern cross_table_t eta_prime_He4_E10_3[344];
extern cross_table_t eta_prime_He4_E10_4[344];
extern cross_table_t eta_prime_He4_E10_5[344];
extern cross_table_t eta_prime_He4_E10_6[344];
extern cross_table_t eta_prime_He4_E10_7[344];
extern cross_table_t eta_prime_He4_E10_8[344];
extern cross_table_t eta_prime_He4_E10_9[344];
extern cross_table_t eta_prime_He4_E11_0[344];
extern cross_table_t eta_prime_He4_E11_1[344];


