

#include "psim.h"

/********************************************************/
/* This creates a photon 50 cm upstream from the target */
/* with energy E                                        */
/********************************************************/

int photon(float E)
{
   float VERT[3];
   float PLAB[3];
   float UBUF;
   int IPART=ptype_gamma;
   int NVTX,NT;
   static float theta=0.0,phi=0.0;
   
   VERT[0]=thargt_.thrpos[0];
   VERT[1]=thargt_.thrpos[1];
   VERT[2]=thargt_.thrpos[2]-50.0;
   
   gsvert_(VERT,&zero,&zero,&UBUF,&zero,&NVTX);
   initial_position.x=VERT[0];
   initial_position.y=VERT[1];
   initial_position.z=VERT[2];

/*  
   E=5.6;
   theta+= PI/1000.0;
   if(theta>PI/2.0)theta=0.0;
   phi   = PI/2.0;
*/   
   PLAB[0]=E*sin(theta)*cos(phi);
   PLAB[1]=E*sin(theta)*sin(phi);
   PLAB[2]=E*cos(theta);
   
   if(!flags[generate_only])gskine_(PLAB,&IPART,&NVTX,&UBUF,&zero,&NT);
   initial_4vect.E=E;
   initial_4vect.x=PLAB[0];
   initial_4vect.y=PLAB[1];
   initial_4vect.z=PLAB[2];

   return 0;
}













