

#include "psim.h"

/* real primakoff event generator */

void primakoff(float E)
{
   float VERT[3]={0.0,0.0,0.0};
   float PLAB[3]={0.0,0.0,0.0};
   float UBUF;
   float cube_size;
   int IPART=ptype_pion_zero;
   int NVTX,NT;
   
   /* determine initial position and direction of pi0 */
   /* randomly place in a 10E-3 cm cube */
   cube_size=10.0E-3;
   
   VERT[0] = cube_size*((float)random()/(float)RAND_MAX -1.0);
   VERT[1] = cube_size*((float)random()/(float)RAND_MAX -1.0);
   VERT[2] = cube_size*((float)random()/(float)RAND_MAX -1.0);
   gsvert_(VERT,&zero,&zero,&UBUF,&zero,&NVTX);
   initial_position.x=VERT[0];
   initial_position.y=VERT[1];
   initial_position.z=VERT[2];
   
   /* just give it the full photon energy for now */
   PLAB[2]=sqrt(E*E - 0.1346*0.1346);

   gskine_(PLAB,&IPART,&NVTX,&UBUF,&zero,&NT);
   initial_4vect.E=E;
   initial_4vect.x=PLAB[0];
   initial_4vect.y=PLAB[1];
   initial_4vect.z=PLAB[2];
      
}

