C
C****************************************************************************
C                                                                           *
C         Date: 11/09/97                                                    *
C         author: A. Gasparian                                              *
C                                                                           *
C                                                                           *
C  Modified 6/26/98 by D. Lawrence                                          *                                         *
C  3/14/00 D. Lawrence  Moved detector positioning into calorimeter_pi.f    *
C...........................................................................*.
C.
      SUBROUTINE CALORIMETER
C
      COMMON/GCLINK/JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
C
      COMMON/NEWDET/PI0DET(4),LGWIDTH,LGLENGTH,INWIDTH,INLENGTH,WRAP
     +      ,AIRGAP
C
      DIMENSION PAR( 8)

      REAL PI0DET,LGWIDTH,LGLENGTH,INWIDTH,INLENGTH,WRAP,AIRGAP
      REAL PAR
C
C
C
C
C********************************************************
C   Define detector and wrapping dimensions
C********************************************************
      LGWIDTH  =  4.25
      LGLENGTH = 34.0
      INWIDTH  =  2.125
      INLENGTH = 20.0
      WRAP     =  0.0025
      AIRGAP   =  0.005
C
C
C********************************************************
C   Define a dummy wall of air to force GEANT to 
C   step across its boundary
C********************************************************
      PAR(1) = 200
      PAR(2) = PAR(1)
      PAR(3) = (LGLENGTH/2.0)+AIRGAP+WRAP
      CALL GSVOLU( 'AIRW' , 'BOX ' , 1, PAR , 3 , IVOL )
      ZSOP = PI0DET(3)+PAR(3)
      CALL GSPOS( 'AIRW' ,5000, 'HALB' ,0.0, 0.0, ZSOP, 0,'MANY')
C
C
C********************************************************
C           Define Lead-Glass Brick (with wrapping)
C*******************************************************
C      Shower dwtectors are 4x4x40 cm^3
C       I took TF-1
C
C.  ............    .... CREATING  DET. 'TTSW'
C
      PAR(1) = (LGWIDTH/2.0) +AIRGAP+WRAP
      PAR(2) = PAR(1)
      PAR(3) = (LGLENGTH/2.0)+AIRGAP+WRAP
C                                                   Optic Al mirror  #3
      CALL GSVOLU( 'TTSW' , 'BOX ' , 3, PAR , 3 , IVOL )
C
C.. CREATING VOLUME 'TTAI'   AIR GAP FOR PRESHOWER DET
C                                                                    #4
      PAR(1) = (LGWIDTH/2.0) +AIRGAP
      PAR(2) = PAR(1)
      PAR(3) = (LGLENGTH/2.0)+AIRGAP
      CALL GSVOLU( 'TTAI' , 'BOX ' , 4, PAR , 3 , IVOL )
C
C.. CREATING VOLUME 'TF_1'   GLASS TF-1                              #2
C
      PAR(1) = (LGWIDTH/2.0)
      PAR(2) = PAR(1)
      PAR(3) = (LGLENGTH/2.0)
      CALL GSVOLU( 'TF_1' , 'BOX ' , 2, PAR , 3 , IVOL )
C
C......               POSITIONING ALL IN 'TTSW'
      XSOP =0.000
      YSOP =0.000
      ZSOP =0.000
      CALL GSPOS( 'TF_1' , 1 , 'TTAI' ,XSOP,YSOP,ZSOP, 0,'ONLY')
C
      CALL GSPOS( 'TTAI' , 1 , 'TTSW' ,XSOP,YSOP,ZSOP, 0,'ONLY')
C.
C
C
C********************************************************
C           Define Insertion Brick (with wrapping)
C*******************************************************
C      Insertion detectors are 2x2x20 cm^3
C
C.  ............    .... CREATING  DET. 'TTSW'
C
      PAR(1) = (INWIDTH/2.0) +AIRGAP+WRAP
      PAR(2) = PAR(1)
      PAR(3) = (INLENGTH/2.0)+AIRGAP+WRAP
C                                                   Optic Al mirror  #3
      CALL GSVOLU( 'TTIN' , 'BOX ' , 3, PAR , 3 , IVOL )
C
C.. CREATING VOLUME 'TTIA'   AIR GAP FOR PRESHOWER DET
C                                                                    #4
      PAR(1) = (INWIDTH/2.0) +AIRGAP
      PAR(2) = PAR(1)
      PAR(3) = (INLENGTH/2.0)+AIRGAP
      CALL GSVOLU( 'TTIA' , 'BOX ' , 4, PAR , 3 , IVOL )
C
C.. CREATING VOLUME 'TF_2'   PbWO4                                   #2
C
      PAR(1) = (INWIDTH/2.0)
      PAR(2) = PAR(1)
      PAR(3) = (INLENGTH/2.0)
      CALL GSVOLU( 'TF_2' , 'BOX ' , 22, PAR , 3 , IVOL )
C
C......               POSITIONING ALL IN 'TTIN'
      XSOP =0.000
      YSOP =0.000
      ZSOP =0.000
      CALL GSPOS( 'TF_2' , 1 , 'TTIA' ,XSOP,YSOP,ZSOP, 0,'ONLY')
C
      CALL GSPOS( 'TTIA' , 1 , 'TTIN' ,XSOP,YSOP,ZSOP, 0,'ONLY')
C
C

      RETURN
      END
C
C










