C.*************************************************************************
*____ Author :A. Gasparian                                                *
*____ date : 10/10/97                                                     *
*                                                                         *
C.   DEFINITION OF DIPOLE GEOMETRY For Real Primakoff Experiment          *
C    tempor.ly dipole gap in X der. is changed from +/- 7.5 to +/- 15.0cm *
C.*************************************************************************
C
      SUBROUTINE DIPOLE
C.
      COMMON/GCLINK/JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
C.
      COMMON/POSITO/POSIT(5)
      COMMON/MSTRNT/STRENT(5)
      COMMON/EDGMAG/POSBGN(5),POSEND(5)
      COMMON/STRCON/GCONS(5)
      COMMON/QUADRD/BORRAD(5),BORSQ(5)
      COMMON/QUADHL/HALFLG(5)
      COMMON/COLLDP/COLLIM
C
      DIMENSION PAR( 8)

C
C  	Magnetic Air volume to place dipole in.
C	 	This is eaxtly the same size as the dipole in x and y
C	 	but extends some in z to allow for fringe field effects.
C
      PAR(1) = 104.8
      PAR(2) = 58.1
      PAR(3) = 55.0
      CALL GSVOLU( 'DPEN','BOX ', 23 ,PAR,3,IVOL)

C
C	 	Iron dipole magnet
C
      PAR(1) = 104.8
      PAR(2) = 58.1
      PAR(3) = 45.72
      CALL GSVOLU( 'DPOL','BOX ',12 ,PAR,3,IVOL)             ! MOLL.  DIPOL

C
C	 	Vaccuum box inside of dipole (note the physical box is
C	 	not included at this time).
C
      PAR(1) = 23.1775
      PAR(2) = 10.319
      PAR(3) = 45.72
      CALL GSVOLU( 'DVGP','BOX ', 11 ,PAR,3,IVOL)              

C
C	 	Thin slots on the sides of the gaps
C	 	This is implemented as just another vaccuum box which
C	 	overlaps the above in the middle
C
      PAR(1) = 40.000
      PAR(2) = 2.667
      PAR(3) = 45.72
      CALL GSVOLU( 'DVSL','BOX ', 11 ,PAR,3,IVOL)              


C
C		POSITIONING    'DVGP'  INSIDE  'DPOL' 
      XPOS =  0.000
      YPOS =  0.000
      ZPOS =  0.000
      CALL GSPOS( 'DVGP' ,3002, 'DPOL' ,XPOS,YPOS,ZPOS, 0,'ONLY')

C
C		POSITIONING    'DVSL'  INSIDE  'DPOL' 
      XPOS =  0.000
      YPOS =  0.000
      ZPOS =  0.000
      CALL GSPOS( 'DVSL' ,3003, 'DPOL' ,XPOS,YPOS,ZPOS, 0,'ONLY')

C
C		POSITIONING    'DPOL'  INSIDE  'DPEN' 
      XPOS =  0.000
      YPOS =  0.000
      ZPOS =  0.000
      CALL GSPOS( 'DPOL' ,3001, 'DPEN' ,XPOS,YPOS,ZPOS, 0,'ONLY')

C
C		POSITIONING    'DPEN'  INSIDE  'HALB' 
      XPOS =  0.000
      YPOS =  0.000
      ZPOS =  POSIT(1)
      CALL GSPOS( 'DPEN' ,3000, 'HALB' ,XPOS,YPOS,ZPOS, 0,'MANY')
C
C
      RETURN
      END
C
C.
C.......
C.
C
C.*************************************************************************
*____ Author :A. Gasparian                                                *
*____ date : 09/22/96                                                     *
*                                                                         *
C.   DEFINITION OF some dummy volume for coordinate    definition         *
*                                                                         *
*                                                                         *
C.*************************************************************************
C
      SUBROUTINE DUMMY
C.
      COMMON/GCLINK/JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
C.
      COMMON/POSITO/POSIT(5)
      COMMON/ZPLANE/ZPLN(5)
      COMMON/MSTRNT/STRENT(5)
      COMMON/EDGMAG/POSBGN(5),POSEND(5)
      COMMON/STRCON/GCONS(5)
      COMMON/QUADRD/BORRAD(5),BORSQ(5)
      COMMON/QUADHL/HALFLG(5)
      COMMON/COLLDP/COLLIM
C
      DIMENSION PAR( 8)
C.
C     dummy volume for coordinate difinition at downstream of dipole coils
C
      PAR(1) = 100.000
      PAR(2) = 100.000
      PAR(3) =  1.000
C..
C      NMED1 = 1             AIR not mag                     ! AIRE not mag
C
      CALL GSVOLU( 'DUMY','BOX ', 1 ,PAR,3,IVOL)             !  'DUMY'
C
C
      RETURN
      END
C.
C



