


extern "C" {
   #include <psim.h>

	void vetocntr_(void);
   void vetocntr_eta_(void);
}

//======================================================
// Here are defined the charged particle veto counters.
// specific for Primakoff eta
//=======================================================



void vetocntr_eta_(void)
{
	float PAR[3];
	float thick,w;
	int base;
	int IVOL,ISET,IDET;
	float x,y,z;

	// Use the same veto couters as for pi0
	vetocntr_();

	//------------ Eta specific veto counters ---------------
	thick = 0.5;
	w=newdet_.lgwidth;
	z=newdet_.pi0d[2]+(newdet_.lglength/2.0);
	base=1900;

	// Top and bottom 
	PAR[0] = ((2.0*w) - thick)/2.0;
	PAR[1] = thick/2.0;
	PAR[2] = newdet_.lglength/2.0;
	gsvolu("VET4","BOX ", 5 ,PAR,3,&IVOL);

	gspos("VET4" ,base+0, "HALB" ,-w+PAR[0],+w-PAR[1],z, 0,"MANY");
	gspos("VET4" ,base+1, "HALB" ,+w-PAR[0],-w+PAR[1],z, 0,"MANY");

	// Left and Right
	PAR[1] = ((2.0*w) - thick)/2.0;
	PAR[0] = thick/2.0;
	gsvolu("VET5","BOX ", 5 ,PAR,3,&IVOL);

	gspos("VET5" ,base+2, "HALB" ,-w+PAR[0],-w+PAR[1],z, 0,"MANY");
	gspos("VET5" ,base+3, "HALB" ,+w-PAR[0],+w-PAR[1],z, 0,"MANY");

	gsdetv("VETO","VET4",base,100,100,&ISET,&IDET);
	gsdetv("VETO","VET5",base,100,100,&ISET,&IDET);

}




