


#include "psim.h"


char OUTFILE[256];

void book_histos(void)
{
   int i,j;
   subset *s;
   char str[1024];

   /* initialize trigger simulators */
   init_trigger();
   init_trigger2();
   init_trigger3();
   init_trigger4();
   init_trigger5();


   /*******************************************/
   /*             define histograms           */
   /*******************************************/
   
   hbook1(1,"Initial photon energy (GeV)",200,0.0,12.0,0.0);

   hbook1(2,"Total Energy deposited in Calorimeter (GeV)",1000,0.0,12.0,0.0);
   hbook1(20,"Total Energy deposited in Calorimeter (GeV) 3x3",1000,0.0,12.0,0.0);
   hbook1(21,"Total Energy deposited in Calorimeter (GeV) 5x5",1000,0.0,12.0,0.0);
   hbook1(22,"Total Energy deposited in Calorimeter (GeV) 7x7",1000,0.0,12.0,0.0);

   if(GEOMETRY_TYPE==0){
   	hbook1(3,"Total Energy deposited in Outer (GeV)",600,0.0,6.0,0.0);   
   	hbook1(4,"Total Energy deposited in Insertion (GeV)",600,0.0,6.0,0.0);

	   hbook1(1001,"Trigger Info",40,0.0,20.0,0.0);
   	hbook1(1002,"7strip xbits",40,0.0,20.0,0.0);
   	hbook1(1003,"7strip ybits",40,0.0,20.0,0.0);
   	hbook1(1004,"15strip xbits",40,0.0,20.0,0.0);
   	hbook1(1005,"15strip ybits",40,0.0,20.0,0.0);
   	hbook1(1006,"middle strip group rates",40,0.0,20.0,0.0);
   	hbook1(1007,"trig1 x discriminator hits",10,0.0,10.0,0.0);
   	hbook1(1008,"trig1 y discriminator hits",10,0.0,10.0,0.0);
   	hbook1(1009,"trig5 xlo discriminator hits",10,0.0,10.0,0.0);
   	hbook1(1010,"trig5 ylo discriminator hits",10,0.0,10.0,0.0);
   	hbook1(1011,"trig5 xhi discriminator hits",10,0.0,10.0,0.0);
   	hbook1(1012,"trig5 yhi discriminator hits",10,0.0,10.0,0.0);

   	hbook1(1200,"number of outers hit",200,0.0,200.0,0.0);
   	hbook1(1201,"number of inners hit",200,0.0,200.0,0.0);

	   /* Pair Counters */
	   hbook1(2001,"Upstream, left pair counter",2048,0.0,0.02048,0.0);	   
	   hcopy(2001,2002,"Downstream, left pair counter");	   
	   hcopy(2001,2003,"Upstream, right pair counter");	   
	   hcopy(2001,2004,"Downstream, right pair counter");

	   hbook1(3000,"invariant mass",1200,0.0,1.2,0.0);
   	hbook1(3002,"pi0 opening angle (degrees)",200,0.0,40.0,0.0);


	   /* X-Y plot of pairs (photons) at calorimeter face */
	   hbook2(5000,"Y vs X pairs" ,100 ,-0.70 ,0.70 ,100 ,-0.70 ,0.70 ,0.0);
	   hbook2(5001,"Y vs X photons" ,100 ,-0.70 ,0.70 ,100 ,-0.70 ,0.70 ,0.0);
	   hbook2(5002,"theta1 vs theta2 photons" ,100 ,0.0 ,90.0 ,100 ,0.0 ,90.0 ,0.0);
	   hbook2(5003,"theta1 vs theta2 photons generator" ,100 ,0.0 ,90.0 ,100 ,0.0 ,90.0 ,0.0);
   
		/* Re-Tracing for accidentals */
		hbook2(4000,"X vs Z tracks",200,0.0,750.0,1100,-15.0,15.0,0.0);
	}else{
		hbook2(3,"E vs R" ,75 ,0.0 ,75.0 ,1000 ,0.0 ,4.0 ,0.0);
		
   	hbook1(1200,"number of blocks hit",200,0.0,200.0,0.0);
   	
		hbook1(2000,"number of 1GeVphotons C12 eta->2gamma",21,-0.5,20.5,0);
		hbook1(2001,"number of 1GeVphotons C12 eta->3pi0",21,-0.5,20.5,0);
		hbook1(2002,"number of 1GeVphotons C12 eta->pi+ pi- pi0",21,-0.5,20.5,0);
		hbook1(2003,"number of 1GeVphotons C12 eta->pi+ pi- gamma",21,-0.5,20.5,0);
   	
		hbook1(2400,"number of photons He4 eta->2gamma",21,-0.5,20.5,0);
		hbook1(2401,"number of photons He4 eta->3pi0",21,-0.5,20.5,0);
		hbook1(2402,"number of photons He4 eta->pi+ pi- pi0",21,-0.5,20.5,0);
		hbook1(2403,"number of photons He4 eta->pi+ pi- gamma",21,-0.5,20.5,0);
   	
		hbook1(2500,"number of photons C12 eta->2gamma",21,-0.5,20.5,0);
		hbook1(2501,"number of photons C12 eta->3pi0",21,-0.5,20.5,0);
		hbook1(2502,"number of photons C12 eta->pi+ pi- pi0",21,-0.5,20.5,0);
		hbook1(2503,"number of photons C12 eta->pi+ pi- gamma",21,-0.5,20.5,0);

		hbook1(2600,"number of photons C12 eta'->pi+ pi- eta",21,-0.5,20.5,0);
		hbook1(2601,"number of photons C12 eta'->rho gamma",21,-0.5,20.5,0);
		hbook1(2602,"number of photons C12 eta'->pi0 pi0 eta",21,-0.5,20.5,0);
		hbook1(2603,"number of photons C12 eta'->omega gamma",21,-0.5,20.5,0);
		hbook1(2604,"number of photons C12 eta'->2gamma",21,-0.5,20.5,0);
   	
		hbook1(2700,"number of photons He4 eta'->pi+ pi- eta",21,-0.5,20.5,0);
		hbook1(2701,"number of photons He4 eta'->rho gamma",21,-0.5,20.5,0);
		hbook1(2702,"number of photons He4 eta'->pi0 pi0 eta",21,-0.5,20.5,0);
		hbook1(2703,"number of photons He4 eta'->omega gamma",21,-0.5,20.5,0);
		hbook1(2704,"number of photons He4 eta'->2gamma",21,-0.5,20.5,0);
   	
		hbook1(2800,"number of photons rho->pi+ pi-",21,-0.5,20.5,0);
   	
		hbook1(2900,"number of photons omega->pi+ pi- pi0",21,-0.5,20.5,0);
		hbook1(2901,"number of photons omega->pi0 gamma",21,-0.5,20.5,0);
		hbook1(2902,"number of photons omega->pi+ pi-",21,-0.5,20.5,0);

   	
		hbook1(3400,"Energy deposited He4 eta->2gamma",600,0.0,6.0,0);
		hbook1(3401,"Energy deposited He4 eta->3pi0",600,0.0,6.0,0);
		hbook1(3402,"Energy deposited He4 eta->pi+ pi- pi0",600,0.0,6.0,0);
		hbook1(3403,"Energy deposited He4 eta->pi+ pi- gamma",600,0.0,6.0,0);
   	
		hbook1(3500,"Energy deposited C12 eta->2gamma",600,0.0,6.0,0);
		hbook1(3501,"Energy deposited C12 eta->3pi0",600,0.0,6.0,0);
		hbook1(3502,"Energy deposited C12 eta->pi+ pi- pi0",600,0.0,6.0,0);
		hbook1(3503,"Energy deposited C12 eta->pi+ pi- gamma",600,0.0,6.0,0);

		hbook1(3600,"Energy deposited C12 eta'->pi+ pi- eta",600,0.0,6.0,0);
		hbook1(3601,"Energy deposited C12 eta'->rho gamma",600,0.0,6.0,0);
		hbook1(3602,"Energy deposited C12 eta'->pi0 pi0 eta",600,0.0,6.0,0);
		hbook1(3603,"Energy deposited C12 eta'->omega gamma",600,0.0,6.0,0);
		hbook1(3604,"Energy deposited C12 eta'->2gamma",600,0.0,6.0,0);
   	
		hbook1(3700,"Energy deposited He4 eta'->pi+ pi- eta",21,-0.5,20.5,0);
		hbook1(3701,"Energy deposited He4 eta'->rho gamma",21,-0.5,20.5,0);
		hbook1(3702,"Energy deposited He4 eta'->pi0 pi0 eta",21,-0.5,20.5,0);
		hbook1(3703,"Energy deposited He4 eta'->omega gamma",21,-0.5,20.5,0);
		hbook1(3704,"Energy deposited He4 eta'->2gamma",21,-0.5,20.5,0);
   	
		hbook1(3800,"Energy deposited rho->pi+ pi-",600,0.0,6.0,0);
   	
		hbook1(3900,"Energy deposited omega->pi+ pi- pi0",600,0.0,6.0,0);
		hbook1(3901,"Energy deposited omega->pi0 gamma",600,0.0,6.0,0);
		hbook1(3902,"Energy deposited omega->pi+ pi-",600,0.0,6.0,0);

		hbook1(4000,"Single photon Rmax   C12 eta->2gamma",75,0.0,75.0,0);
		hbook1(4001,"Double photon Rmax-1 C12 eta->2gamma",75,0.0,75.0,0);
		hbook1(4002,"Single photon Rmax   C12 eta->3pi0",75,0.0,75.0,0);
		hbook1(4003,"Double photon Rmax-1 C12 eta->3pi0",75,0.0,75.0,0);
		hbook1(4004,"Single photon Rmax   C12 eta->pi+ pi- pi0",75,0.0,75.0,0);
		hbook1(4005,"Double photon Rmax-1 C12 eta->pi+ pi- pi0",75,0.0,75.0,0);

		hbook1(4100,"Single 1GeVphoton Rmax   C12 eta->2gamma",75,0.0,75.0,0);
		hbook1(4101,"Double 1GeVphoton Rmax-1 C12 eta->2gamma",75,0.0,75.0,0);
		hbook1(4102,"Single 1GeVphoton Rmax   C12 eta->3pi0",75,0.0,75.0,0);
		hbook1(4103,"Double 1GeVphoton Rmax-1 C12 eta->3pi0",75,0.0,75.0,0);
		hbook1(4104,"Single 1GeVphoton Rmax   C12 eta->pi+ pi- pi0",75,0.0,75.0,0);
		hbook1(4105,"Double 1GeVphoton Rmax-1 C12 eta->pi+ pi- pi0",75,0.0,75.0,0);

		hbook2(4200,"Max energy photon vs. R",150,0.0,150,120,0.0,12.0,0);
		hbook2(4300,"Ncharged vs Ngamma 1GeVthresh",8,-0.5,7.5,8,-0.5,7.5,0);
		hbook1(4400,"Bin1=no trigger Bin2=good trigger",2,0.5,2.5,0);
	}
	
   hbook1(5,"Initial phi",400,0.0,360.0,0.0);

   hbook1(6,"Initial theta",600,0.0,180.0,0.0);

   hbook1(7,"Energy in VAW",600,0.0,6.0,0.0);

   hbook2(8,"Initial theta vs. subtype",32.0,-0.5,31.5,2000,0.0,100.0,0.0);
   hbook2(9,"Initial theta vs decay mech",32.0,-0.5,31.5,2000,0.0,100.0,0.0);


   hbook1(1000,"Type of event generated",50,0.0,50.0,0.0);

   hbook2(1100,"Energy deposition distribution"
      ,100,-25.0,25.0,110,-25.0,25.0,0.0);
   
   hbook2(1204,"Initial hit distribution"
      ,110,-55.0,55.0,110,-55.0,55.0,0.0);
   hbook2(1205,"Energy weighted initial hit distribution"
      ,110,-55.0,55.0,110,-55.0,55.0,0.0);
   hbook1(1206,"initial hits x-projection",220,-55.0,55.0,0.0);
   hbook1(1207,"initial hits y-projection",220,-55.0,55.0,0.0);
   hbook2(1208,"Energy in VAW weighted initial hit distribution"
      ,110,-55.0,55.0,110,-55.0,55.0,0.0);
   hbook1(1300,"initial hits x-projection 10MeV thresh",225,-75.0,75.0,0.0);
   hbook1(1301,"initial hits x-projection 100MeV thresh",225,-75.0,75.0,0.0);
   hbook1(1302,"initial hits x-projection 1GeV thresh",225,-75.0,75.0,0.0);
   hbook1(1303,"initial hits x-projection 2GeV thresh",225,-75.0,75.0,0.0);
   hbook1(1304,"initial hits x-projection 5GeV thresh",225,-75.0,75.0,0.0);
   hbook1(1305,"initial hits x-projection 7GeV thresh",225,-75.0,75.0,0.0);
   hbook1(1306,"initial hits x-projection 9GeV thresh",225,-75.0,75.0,0.0);
   hbook1(1310,"initial hits y-projection 10MeV thresh",225,-75.0,75.0,0.0);
   hbook1(1311,"initial hits y-projection 100MeV thresh",225,-75.0,75.0,0.0);
   hbook1(1312,"initial hits y-projection 1GeV thresh",225,-75.0,75.0,0.0);
   hbook1(1313,"initial hits x-projection 2GeV thresh",225,-75.0,75.0,0.0);
   hbook1(1314,"initial hits x-projection 5GeV thresh",225,-75.0,75.0,0.0);
   hbook1(1315,"initial hits x-projection 7GeV thresh",225,-75.0,75.0,0.0);
   hbook1(1326,"initial hits x-projection 9GeV thresh",225,-75.0,75.0,0.0);




   /* make ntuples (RWN) for particles hitting calorimeter */
   /*          1234567812345678123456781234567812345678    */
#if 0
   strcpy(str,"X1      Y1      Z1      pid1    E1      ");
   strcat(str,"X2      Y2      Z2      pid2    E2      ");
   strcat(str,"Ephoton Edep    dist    good    trig    ");
   strcat(str,"xbits   ybits   trig2   trig3   trig4   ");
   strcat(str,"trig5   ");
   hbookn(nt3,"rateInfo",strlen(str)/8,"//LUN1",100000,str);
#endif

   /*******************************************/
   /*             define subsets              */
   /*******************************************/

#if 0   
   /* make ntuple nt1 (CWN) */
   hbnt(nt1,"E_and_T"," ");
   
   /* add some variables */
   hbname(nt1,"PARM",&event_type,"event_type:I");
#endif

   /* all detectors */
   if(GEOMETRY_TYPE==0){
   	if(!SubsetExists("ALL")){
      	s=AddSubset("ALL");
      	if(s){
         	for(i=1;i<=27;i++)
            	for(j=1;j<=27;j++)
               	if(i<9 || i>19 || j<9 || j>19)
                  	s->list[s->Num++]=(27*(j-1))+i;
            
         	for(i=1;i<=22;i++)
            	for(j=1;j<=22;j++)
               	if(i<11 || i>12 || j<11 || j>12)
                  	s->list[s->Num++]=(22*(j-1))+i+1000;
      	}        
   	}
   	
   
   	/* outer array */
   	s=AddSubset("OUTER");
   	if(s){
      	for(i=1;i<=27;i++)
         	for(j=1;j<=27;j++)
            	if(i<9 || i>19 || j<9 || j>19)s->list[s->Num++]=(27*(j-1))+i; 
   	}

   	/* insertion array */
   	s=AddSubset("INNER");
   	if(s){
      	for(i=1;i<=22;i++)
         	for(j=1;j<=22;j++)
            	if(i<11 || i>12 || j<11 || j>12)s->list[s->Num++]=(22*(j-1))+i+1000;
   	}

   	/* Pair counters */
   	s=AddSubset("PC");
   	if(s){
      	s->list[s->Num++]=2001;
      	s->list[s->Num++]=2002;
      	s->list[s->Num++]=2003;
      	s->list[s->Num++]=2004;
   	}
   	/* Beam Left Pair counters */
   	s=AddSubset("PCL");
   	if(s){
      	s->list[s->Num++]=2001;
      	s->list[s->Num++]=2002;
   	}
   	/* Beam Right Pair counters */
   	s=AddSubset("PCR");
   	if(s){
      	s->list[s->Num++]=2003;
      	s->list[s->Num++]=2004;
   	}
   }else if (GEOMETRY_TYPE==1){

   	if(!SubsetExists("ALL")){
      	s=AddSubset("ALL");
      	if(s){
         	for(i=1;i<=35;i++)
            	for(j=1;j<=35;j++)
               	s->list[s->Num++]=(35*(j-1))+i;
            
      	}        
   	}
   	if(!SubsetExists("HOLE3")){
      	s=AddSubset("HOLE3");
      	if(s){
         	for(i=17;i<=19;i++)
            	for(j=17;j<=19;j++)
               	s->list[s->Num++]=(35*(j-1))+i;
            
      	}        
   	}
   	if(!SubsetExists("HOLE5")){
      	s=AddSubset("HOLE5");
      	if(s){
         	for(i=16;i<=20;i++)
            	for(j=16;j<=20;j++)
               	s->list[s->Num++]=(35*(j-1))+i;
            
      	}        
   	}
   	if(!SubsetExists("HOLE7")){
      	s=AddSubset("HOLE7");
      	if(s){
         	for(i=15;i<=21;i++)
            	for(j=15;j<=21;j++)
               	s->list[s->Num++]=(35*(j-1))+i;
            
      	}        
   	}

   	s=AddSubset("OUTER");
   	s=AddSubset("INNER");
   	s=AddSubset("PC");
   	s=AddSubset("PCL");
   	s=AddSubset("PCR");
   }
   
}



