C
C**************************************************************************
C                                                                         *
C-- Date: 11/12/97                                                        *
C-- Author : A. Gasparian                                                 *
C                                                                         *
C      INTERACTEV VERSION OF                                              *
C......GEANT SIMULATION PROGRAM FOR HALL B Real Promakoff Experiment      *
C.                                               GEANT VERSION   3.21     *
C.                                               PROGRAM VERSION 1.01     *
C.                                                                        *
C.                 this one with moving tharget                           *
C                                                                         *
C.*************************************************************************
C
C
C--------------------   DATA CARD USER FLAGS:  ---------------------
C
C
C  SWIT(10) ==> CHERENKOV PHOTONS TRACKING IN TOTAL SHOWER DETECTORS
C           =0  TURNS OFF CH. PHOTONS TRACKING
C           =1,2,...10,...100,.. TRACKS EVERY i-th ch. ph. gener-ed in TOTAL
C               shower detectors
C
C  SWIT( 9) ==> CHERENKOV PHOTONS TRACKING IN PRESHOWER DETECTORS
C           =0  TURNS OFF CH. PHOTONS TRACKING IN PRESHOWER
C           =1,2,...10,...100,.. TRACKS EVERY i-th ch. ph. gener-ed in PRESHOWE
C            detectors.
C
C  SWIT( 8) ==>
C
C
C  SWIT( 7) ==>   TRACKING OF SECONDARIES
C             = 0  NO tracking of secondaries
C             = 1  turn ON tracking of secondaries
C
C                                                     by default ISWIT( 7) = 1
C  SWIT( 6) ==>
C
C
C  SWIT( 5) ==>  GENERATION OF OUTPUT FILES
C            =0  NO OUTPUT FILES
C            =1  turn on output file hag321.dat with only histograms
C            =2      --//--                      hist.s and Ntuple
C            =3      --//-- plus FOR018.DAT file with detail informa-
C                            tion about all detector responses
C            =4   only file FOR018.DAT generated
C
C                                                    by default ISWIT( 5) = 0
C  SWIT( 1) ==>  SHOWING OF TRACKS
C            =0  TRACKS ARE NOT SHOWING
C            =1  TRACKS ARE SHOWING   ( if IDEBUG=1 too )
C
C
C  HRSE    ==>  ELECTRON ARM PARAMETERS
C  HRSE( 1)=> specrometer angle in degres (positive, from beam line)
C      ( 2)=> spectrometer magn. elements momentume tune(- for neg. + for pos.)
C      ( 3)=> IFIELD  magnetic tracking type
C                =1 strong inhomogeneius field   ! call GRKUTA
C                =2        inhomogeneius field   ! call GHELIX
C      ( 4)=> TMAXFD  max. angular deviation by mag. field in one step (deg.)
C      ( 5)=> PARTICAL TYPE
C
C  HRSH    ==>  HADRON ARM PARAMETERS
C               the some as HRSE
C.....
C.
C.*************************************************************************
*-- Author :A. Gasparian                                                  *
*-- DATE   :9/04/97                                                       *
*                                                                         *
C.    *                                                                   *
C.    *                                                                   *
C.    *        To initialise GEANT  program and read data cards           *
C.    *                                                                   *
*                                                                         *
C.*************************************************************************
C
      SUBROUTINE UGINIT
C.
C.
C
      COMMON/PERTUR/SIG(2)
C
      COMMON/POSITO/POSIT(5)
      COMMON/ZPLANE/ZPLN(5)
      COMMON/MSTRNT/STRENT(5)
      COMMON/EDGMAG/POSBGN(5),POSEND(5)
      COMMON/STRCON/GCONS(5)
      COMMON/QUADRD/BORRAD(5),BORSQ(5)
      COMMON/QUADHL/HALFLG(5)
      COMMON/COLLDP/COLLIM
      COMMON/THARGT/THRPOS(3)
C
      COMMON/PHBMEN/EGFRAC(2)
      COMMON/EQUIPH/QEQUPH
      COMMON/TMCAR4/egammn,egammx,denest
      DOUBLE PRECISION egammx,egammn,denest
C
      COMMON/POSDET/DETPOS(4)
      COMMON/NEWDET/PI0DET(4),LGWIDTH,WRAP,AIRGAP
      COMMON/G1SAMP/CMG1MM(2)
C
      COMMON/HRSANG/ANGLES(2)
      COMMON/ARMSPR/ELARMP(5),HDARMP(5)
      COMMON/SPCFLD/EFLD,HFLD
      COMMON/MAGCUT/CUTMAG(10),MGNSTP
      COMMON/PAIRC/PLENGTH,PWIDTH,PHEIGHT,PPOS(3),PROTY
      COMMON/TARGET/TLENGTH,TWIDTH,THEIGHT

      COMMON/FNAME/INFILE,OUTFILE
      CHARACTER*256 INFILE,OUTFILE
C
      COMMON/GRAPHIC/USEGRAPH,VIEWTH,VIEWPH,VIEWPS,VSCALE
      LOGICAL USEGRAPH
      COMMON/GCFLAX/BATCH,NOLOG
      LOGICAL BATCH,NOLOG
C
      CHARACTER*4 EFLD,HFLD
      DIMENSION ELMSET(6),HDMSET(6)
      EQUIVALENCE (ELMSET(1),EFLD)
      EQUIVALENCE (HDMSET(1),HFLD)
C.
*
*             Open user files
*
      PRINT*,'Opening input file:',INFILE
      OPEN(UNIT=4,FILE=INFILE,STATUS='OLD')
C
C             Initialise GEANT
C
      CALL GINIT
C........        Some default parameters
C
      PRINT*,'Setting some default parameters'
      CALL GASHDF
C
C..        ANGLES(1)   is HRSE angle,
C..        ANGLES(2)   is HRSH angle,  both in degries
C
      PRINT*,'Reading data cards'
      CALL FFKEY('CTMG',CUTMAG,10,'REAL')
      CALL FFKEY('POSI',POSIT,5,'REAL')
      CALL FFKEY('HLEN',HALFLG,5,'REAL')
      CALL FFKEY('MSTR',STRENT,5,'REAL')
      CALL FFKEY('BORR',BORRAD,5,'REAL')
      CALL FFKEY('ZCUT',ZPLN,5,'REAL')
C
C          COLLIM= +/- for collim. position in Dipole
      CALL FFKEY('COLL',COLLIM,1,'REAL')
C          Target Position
      CALL FFKEY('TPOS',THRPOS,3,'REAL')
C          Moller Detector Position
      CALL FFKEY('DTPO',DETPOS,4,'REAL')
C          Pi0 detector Position and angle
      CALL FFKEY('PI0D',PI0DET,4,'REAL')
C          Two Gamma Teta angle sampling in CM
      CALL FFKEY('G1CM',CMG1MM,2,'REAL')
C          Tagged beam equivalent Photon Number in sec
      CALL FFKEY('QEQU',QEQUPH,1,'REAL')
C          Tagged gamma accepted fractions
      CALL FFKEY('EGFR',EGFRAC,2,'REAL')
C
      CALL FFKEY('ELFL',ELMSET,6,'MIXED')
      CALL FFKEY('HRSE',ELARMP,5,'REAL')
      CALL FFKEY('HDFL',HDMSET,6,'MIXED')
      CALL FFKEY('HRSH',HDARMP,5,'REAL')
      CALL FFKEY('SIGM',SIG,2,'REAL')
C
      CALL FFKEY('PRCT',PLENGTH,7,'REAL')
      CALL FFKEY('TGTP',TLENGTH,3,'REAL')

C.
C     'POSI' is position in cm for five moll. pol elements (targ, Q1, Q2, Q3, D)
C     'MSTR' is strentnees of the diff. mag el (G1, G2, G3, B0-for dipole )
C.    'BORR' IS BORE REDIUCE FOR QUADS AND HALF GAP OF DIPOLE IN CM
C
      CALL FFSET('LINP',4)
      CALL GFFGO
      CLOSE(4)
C
C     HALFLG(I) is the half Physical length of  mag. elements
C     Therefore to get half eff. mag. length =HALFLG+BORRAD/2.
      DO I = 1,5
        POSEND(I) = POSIT(I) + HALFLG(I)
        POSBGN(I) = POSIT(I) - HALFLG(I)
      ENDDO
C      
      MGNSTP    = CUTMAG(10)
C
      ANGLES(1) = ELARMP(1)
      ANGLES(2) = HDARMP(1)
C
      PRINT*,'Calling cernlib initializers'
      CALL GZINIT
      IF(USEGRAPH.OR..NOT.BATCH) THEN
        CALL GDINIT
      ENDIF
      CALL GPART
C
C              Geometry and materials description
C
      PRINT*,'Defining geometry'
      CALL ROTMAT
      CALL GUMAT
      CALL GUTMED
      CALL GUGEOM
C
      IF(.NOT.BATCH) THEN
         CALL GLOOK('MATE',LPRIN,NPRIN,IM)
         CALL GLOOK('TMED',LPRIN,NPRIN,IT)
         CALL GLOOK('VOLU',LPRIN,NPRIN,IV)
      ENDIF
C
C              Create a view banks
      CALL HBVIEW
C
C              Energy loss and cross-sections initialisations
C
      PRINT*,'Defining energy loss tables'
      CALL GPHYSI
C
C              Define  histograms
C
      PRINT*,'Defining Histograms'
      CALL UHINIT
C
      PRINT*,'======================================================'
      PRINT*,'              User Initialization complete'
      PRINT*,'======================================================'
C
      RETURN
      END
C.
C.
C
C
C.*************************************************************************
*-- Author :A. Gasparian                                                  *
*-- DATE   :9/02/97                                                       *
*                                                                         *
*                                                                         *
C.               Some default parameters                                  *
*                                                                         *
C.*************************************************************************
C
      SUBROUTINE GASHDF
C.
C.
      COMMON/GCFLAG/IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT,IEORUN
     +        ,IEOTRI,IEVENT,ISWIT(10),IFINIT(20),NEVENT,NRNDM(2)
C
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
C
      COMMON/PERTUR/SIG(2)
      COMMON/HRSANG/ANGLES(2)
      COMMON/ARMSPR/ELARMP(5),HDARMP(5)
      COMMON/SPCFLD/EFLD,HFLD
      COMMON/MAGCUT/CUTMAG(10),MGNSTP
      CHARACTER*4 EFLD,HFLD
      DIMENSION ELMSET(6),HDMSET(6)
      EQUIVALENCE (ELMSET(1),EFLD)
      EQUIVALENCE (HDMSET(1),HFLD)
C.
C.
      ISWIT( 9) = 0
      ISWIT(10) = 0
      ISWIT( 7) = 1
      ISWIT( 5) = 0
C.
      PKINE(1)=4.
      PKINE(2)=0.
      PKINE(3)=0.
C.
      ELARMP(1)=30.
      ELARMP(2)= 4.
      ELARMP(3)= 2.      ! IFIELD=2 inhomogeneous mag. field  ( CALL GHELIX)
      ELARMP(4)= 0.5     ! TMAXFD max. angular deviation by mag. f-d in 1 step
      ELARMP(5)= 3.      ! partical type
      EFLD     ='FMAP'
C
      HDARMP(1)=60.
      HDARMP(2)= 4.
      HDARMP(3)= 2.      ! IFIELD=2 inhomogeneous mag. field  ( CALL GHELIX)
      HDARMP(4)= 0.5     ! TMAXFD max. angular deviation by mag. f-d in 1 step
      HDARMP(5)= 9.      ! partical type
      HFLD     ='FMAP'
C
C...     DEFAULT KINETIC ENERGY CUT LEVEL FOR MAGNETIC INVIRMENT ( GEV )
      CUTMAG(1)= 0.05
      CUTMAG(2)= 0.05
      CUTMAG(3)= 0.05
      CUTMAG(4)= 0.05
      CUTMAG(5)= 0.05
      CUTMAG(10)=1000
      MGNSTEP   =CUTMAG(10)
C.
C.
      RETURN
      END
C.
C........
C.
C
C.************************************************************************
*__ Author: A. Gasparian                                                 *
*-- DATE : 9/09/94                                                       *
*                                                                        *
C.  *       Routine to generate one hadronic interaction                 *
C.  *                                                                    *
C.  *    ==>Called by :GTHADR,GTNEUT                                     *
C.  *                                                                    *
*                                                                        *
C.************************************************************************
C
      SUBROUTINE GUHADR
C.
C.
      COMMON/GCPHYS/IPAIR,SPAIR,SLPAIR,ZINTPA,STEPPA
     +             ,ICOMP,SCOMP,SLCOMP,ZINTCO,STEPCO
     +             ,IPHOT,SPHOT,SLPHOT,ZINTPH,STEPPH
     +             ,IPFIS,SPFIS,SLPFIS,ZINTPF,STEPPF
     +             ,IDRAY,SDRAY,SLDRAY,ZINTDR,STEPDR
     +             ,IANNI,SANNI,SLANNI,ZINTAN,STEPAN
     +             ,IBREM,SBREM,SLBREM,ZINTBR,STEPBR
     +             ,IHADR,SHADR,SLHADR,ZINTHA,STEPHA
     +             ,IMUNU,SMUNU,SLMUNU,ZINTMU,STEPMU
     +             ,IDCAY,SDCAY,SLIFE ,SUMLIF,DPHYS1
     +             ,ILOSS,SLOSS,SOLOSS,STLOSS,DPHYS2
     +             ,IMULS,SMULS,SOMULS,STMULS,DPHYS3
     +             ,IRAYL,SRAYL,SLRAYL,ZINTRA,STEPRA
C.
C.
C.
C          GHEISHA only if IHADR<3   (default)
C          GHEISHA and HADRIN/NUCRIN if IHADR=3
C
      IF (IHADR.NE.4) THEN
         CALL GHEISH
      ELSE
         CALL FLUFIN
      ENDIF
      END
C
C.
C.....
C.
C
C.***************************************************************************
*__ Autor: A. Gasparian                                                     *
*-- DATE : 7/05/94                                                          *
*                                                                           *
C.    *                                                                     *
C.    *   Routine to compute Hadron  inter-n probabilities                  *
C.    *                                                                     *
C.    * ==>Called by : GTHADR,GTNEUT                                        *
C.    *                                                                     *
*                                                                           *
C.***************************************************************************
C
      SUBROUTINE GUPHAD
C.
C.
      COMMON/GCPHYS/IPAIR,SPAIR,SLPAIR,ZINTPA,STEPPA
     +             ,ICOMP,SCOMP,SLCOMP,ZINTCO,STEPCO
     +             ,IPHOT,SPHOT,SLPHOT,ZINTPH,STEPPH
     +             ,IPFIS,SPFIS,SLPFIS,ZINTPF,STEPPF
     +             ,IDRAY,SDRAY,SLDRAY,ZINTDR,STEPDR
     +             ,IANNI,SANNI,SLANNI,ZINTAN,STEPAN
     +             ,IBREM,SBREM,SLBREM,ZINTBR,STEPBR
     +             ,IHADR,SHADR,SLHADR,ZINTHA,STEPHA
     +             ,IMUNU,SMUNU,SLMUNU,ZINTMU,STEPMU
     +             ,IDCAY,SDCAY,SLIFE ,SUMLIF,DPHYS1
     +             ,ILOSS,SLOSS,SOLOSS,STLOSS,DPHYS2
     +             ,IMULS,SMULS,SOMULS,STMULS,DPHYS3
     +             ,IRAYL,SRAYL,SLRAYL,ZINTRA,STEPRA
C.
      IF (IHADR.NE.4) THEN
         CALL GPGHEI
      ELSE
         CALL FLDIST
      ENDIF
      END
C
C
C.....
C.
C.***************************************************************************
*____ Author :A. Gasparian                                                  *
*____ date : 10/17/95                                                       *
*                                                                           *
*                            GUFLD                                          *
*                                                                           *
C.***************************************************************************
C
      SUBROUTINE GUFLD (X,F)
C
      COMMON/MSTRNT/STRENT(5)
      COMMON/EDGMAG/POSBGN(5),POSEND(5)
C
C...
      DIMENSION X(3),F(3)
C.......
C.......       GCONS(I) = STRENT(I)/BORRAD(I)     I= 1,5 ( target is included)
C.......  BORRAD IS HALF GAP FOR QUADS AND DIPOLE IN CM.
C
      F(1) = 0.00000
      F(2) = 0.00000
      F(3) = 0.00000
C                                  Moller Dipole now is #1
      IF(X(3).LT.POSBGN(1)) RETURN
C
      IF(X(3).LE.POSEND(1)) THEN
      F(1) =  0.00000
      F(2) =  STRENT(1)
      F(3) =  0.00000
C
      RETURN
      ELSE
         IF(X(3).LT.POSBGN(2)) RETURN
         IF(X(3).LE.POSEND(2)) THEN
      F(1) =  0.00000
      F(2) =  STRENT(2)
      F(3) =  0.00000
C
         RETURN
         ENDIF
C
      ENDIF
C
C
      RETURN
      END
C
C.
C.....
C.
C
C.*************************************************************************
*____ Author :A. Gasparian                                                *
*____ date : 8/23/94                                                      *
*                                                                         *
*.           Generates Kinematics for primary track                       *
*                                                                         *
C.*************************************************************************
C.
      SUBROUTINE GUKINE
C.
C
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
      PARAMETER (MAXMEC=30)
      COMMON/GCTRAK/VECT(7),GETOT,GEKIN,VOUT(7),NMEC,LMEC(MAXMEC)
     + ,NAMEC(MAXMEC),NSTEP ,MAXNST,DESTEP,DESTEL,SAFETY,SLENG
     + ,STEP  ,SNEXT ,SFIELD,TOFG  ,GEKRAT,UPWGHT,IGNEXT,INWVOL
     + ,ISTOP ,IGAUTO,IEKBIN, ILOSL, IMULL,INGOTO,NLDOWN,NLEVIN
     + ,NLVSAV,ISTORY
CC
      COMMON/POSITO/POSIT(5)
      COMMON/THARGT/THRPOS(3)
      COMMON/CHEREN/SHWDET(2048),TSHWDET(2048)
CC
      COMMON/BRMST1/egamak
CC
      COMMON/DAVE/ZICOP,NHITS
C
      DIMENSION VERTEX(3),PLAB(3)
      SAVE VERTEX,PLAB
      DATA VERTEX/3*0./
      DATA PLAB  /3*0./
C
C     Call C subroutine
      CALL GUKINEC
C
      ZICOP=0
C
C           Kinematics for Real Primakoff
C
      IK=IKINE
C
C 
C  PKINE(1) => is the initial Tagged Photon beam energy in GeV  = EINI
C  PKINE(2) => is +/- DeltaE/E in % for Initial Electron Beam
C N/A  PKINE(3) => is TETA angle of scattered electron in Lab frame(deg.)
C N/A  PKINE(4) => is DELTET aperture ( +/- DElTET is the full angle)(deg.)
C N/A  PKINE(5) => is FI angle of the Scattered Electrons           (deg.)
C N/A  PKINE(6) => is DELDI  aperture (+/-  DELFI is the FULL angle) (deg.)
C N/A  PKINE(7) => is the Epr energy of the Scattered Electron,
C N/A  PKINE(8) => is the +/- DelEpr/Epr in %  
C  PKINE(9) => is the PI0 meson Polar angle with Tagged Photon (deg.)
C  PKINE(10) => is the PI0 meson Azimutal angle --///-----
C  First one here is IKINE => the type of the particle ( be careful )
C 
C
C        sampling of photon energy egamak, for each event
C
      CALL BRENER
C
      VERTEX(1) = 0.
      VERTEX(2) = 0.
      VERTEX(3) = THRPOS(3)-10.0
C
      PLAB(1) = 0.0000
      PLAB(2) = 0.0000
C      PLAB(3) = PKINE(1)
      PLAB(3) = egamak
      PLAB(3) = 5.6
C
      CALL HF1(1,PLAB(3),1.)
C
      CALL GSVERT(VERTEX,0,0,0,0,NVTX)
      CALL GSKINE(PLAB,IK,NVTX,0,0,NT)
C
C
C.    RESET ENERGY DEPOSITION
      EDTTSW=0.
C.
C.
C.....  RESET SHOWER DETECTOR RESPONSES
      DO I=1,2048
       SHWDET(I)=0.000000
       TSHWDET(I)=0.000000
      ENDDO
C
C
C
      RETURN
      END
C.
C
C.
C.
C.*************************************************************************
*____ Author :A. Gasparian                                                *
*____ date : 10/21/97                                                     *
*                                                                         *
*.        Samples gamma with energy according bremsstrahlung beam         *
*         assuming Bethe Gaitler form of Energy                           *
*                                                                         *
C.*************************************************************************
C.
      SUBROUTINE BRENER
C
C
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
C
      COMMON/PHBMEN/EGFRAC(2)
C      COMMON/EQUIPH/QEQUPH
C
      COMMON/TMCAR4/egammn,egammx,denest
      COMMON/BRMST1/egamak
C
      DOUBLE PRECISION egammx,egammn,denest
C
C  PKINE(1) => is the initial Electron beam energy in GeV 
C
      egammx = DBLE(EGFRAC(2))*DBLE(PKINE(1))
      egammn = DBLE(EGFRAC(1))*DBLE(PKINE(1))
C
      CALL GRNDM(RTL,1)
C
C               see page # 38 in the book #2
C
      egamak=SNGL(DEXP(RTL*(DLOG(egammx)-DLOG(egammn))+DLOG(egammn)))
C
C
C
      RETURN
      END
C
C.
C.....
C.
C
C.************************************************************************
*____ Author :A. Gasparian                                               *
*____ date : 8/23/94                                                     *
*                                                                        *
C.    *                                                                  *
C.    *       Routine to control tracking of one event                   *
C.    *                                                                  *
C.    *       Called by GRUN                                             *
C.    *                                                                  *
*.************************************************************************
C
      SUBROUTINE GUTREV
C.
C     Call The Fortran subroutine
      CALL ASTREV
C
C     Call the C subroutine
C      CALL GUTREVC
C.
C     Call the GEANT built-in subroutine
      CALL GTREVE
C.
      RETURN
      END
C.
C......
C.
C*************************************************************************
*____ Author :A. Gasparian                                               *
*____ date   : 9/26/94                                                   *
*                                                                        *
C.************************************************************************
C
      SUBROUTINE ASTREV
C...
      COMMON/NASCOM/EDPRSW,EDAIRG,EDTTSW,EDTOT,NCPTF1,NCPSF5,NCPTOT
      COMMON/CHEREN/SHWDET(2048),TSHWDET(2048)
C.
C
      RETURN
      END
C.
C......
C.
C.************************************************************************
*____ Author :A. Gasparian                                               *
*____ date : 7/12/94                                                     *
*                                                                        *
C.    *                                                                  *
C.    *       This routine called at the end of each tracking step       *
C.    *       INWVOL is different from 0 when the track has reached      *
C.    *       ISTOP is different from 0 if the track has stopped         *
C.    *                                                                  *
C.                                                                       *
C.************************************************************************
C
      SUBROUTINE GUSTEP
C
C      COMMON/GCFLAG/IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT,IEORUN
C     +        ,IEOTRI,IEVENT,ISWIT(10),IFINIT(20),NEVENT,NRNDM(2)
C      PARAMETER (MAXMEC=30)
C      COMMON/GCTRAK/VECT(7),GETOT,GEKIN,VOUT(7),NMEC,LMEC(MAXMEC)
C     + ,NAMEC(MAXMEC),NSTEP ,MAXNST,DESTEP,DESTEL,SAFETY,SLENG
C     + ,STEP  ,SNEXT ,SFIELD,TOFG  ,GEKRAT,UPWGHT,IGNEXT,INWVOL
C     + ,ISTOP ,IGAUTO,IEKBIN, ILOSL, IMULL,INGOTO,NLDOWN,NLEVIN
C     + ,NLVSAV,ISTORY
C
C     Draw tracks if user flag set 
C      
C      IF(ISWIT(1).EQ.1) THEN
C         CALL GSXYZ
C         CALL GDXYZ(0)
C      ENDIF
C
C     Track all secondary particles 
      CALL GSKING(0)
C
C     Call FORTRAN subroutine
      CALL ACC
C
C     Call C subroutine
      CALL GUSTEPC
C
C
      RETURN
      END
C.
C.....
C.
C.************************************************************************
*____ Author :A. Gasparian                                               *
*____ date : 08/20/97                                                    *
*                                                                        *
C.    *                                                                  *
C.    *       This routine called from GUSTEP for acceptance colculation *
C.    *       INWVOL is different from 0 when the track has reached      *
C.    *       ISTOP is different from 0 if the track has stopped         *
C.    *                                                                  *
C.                                                                       *
C.************************************************************************
C
      SUBROUTINE ACC
C
C
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
C
      COMMON/GCSETS/IHSET,IHDET,ISET,IDET,IDTYPE,NVNAME,NUMBV(20)
C
      PARAMETER (MAXMEC=30)
      COMMON/GCTRAK/VECT(7),GETOT,GEKIN,VOUT(7),NMEC,LMEC(MAXMEC)
     + ,NAMEC(MAXMEC),NSTEP ,MAXNST,DESTEP,DESTEL,SAFETY,SLENG
     + ,STEP  ,SNEXT ,SFIELD,TOFG  ,GEKRAT,UPWGHT,IGNEXT,INWVOL
     + ,ISTOP ,IGAUTO,IEKBIN, ILOSL, IMULL,INGOTO,NLDOWN,NLEVIN
     + ,NLVSAV,ISTORY
C
      COMMON/NASCOM/EDPRSW,EDAIRG,EDTTSW,EDTOT,NCPTF1,NCPSF5,NCPTOT
      COMMON/CHEREN/SHWDET(2048),TSHWDET(2048)
      COMMON/DAVE/ZICOP,NHITS
C
C
C
C                    Energy Deposition in Shower Detectors
C
C     Is particle in lead-glass ?
      IF(IDTYPE.NE.0) THEN
C
C       ICOP is the detector number (1 to 625 for lead glass
C                                    1000 to 1484 for insertion
C                                    2001 to 2004 for pair cntr)
        ICOP=NUMBV(1)
C
C       Remember detector number so we can histogram in GUOUT
        ZICOP=ICOP
C
C       If first time a detector is hit this event, record time
        IF(TSHWDET(ICOP).EQ.0) THEN
         TSHWDET(ICOP) = TOFG
        ENDIF
C
C       Add energy loss to the detector we're currently in
        SHWDET(ICOP) = SHWDET(ICOP) + DESTEP
C      
        EDTTSW = EDTTSW + DESTEP
C
      ENDIF
C
C
      RETURN
      END
C
C
C
C......
C.
C
C.************************************************************************
*____ Autor :A. Gasparian                                                *
*____ data : 7/21/94                                                     *
*                                                                        *
*                                                                        *
C.************************************************************************
C
      SUBROUTINE GUOUT
C
      COMMON/NASCOM/EDPRSW,EDAIRG,EDTTSW,EDTOT,NCPTF1,NCPSF5,NCPTOT
      COMMON/CHEREN/SHWDET(2048),TSHWDET(2048)
C
      COMMON/DAVE/ZICOP,NHITS
C
C     Histogram of detector numbers hit
      IF(ZICOP.GT.0) THEN
       CALL HF1(3,ZICOP,1.)
      ENDIF
C
C
C     Call C subroutine
      CALL GUOUTC
C
      IF(SHWDET(2001).gt.0) then 
      CALL HF1(2001,SHWDET(2001),1.)
      endif
      IF(SHWDET(2002).gt.0) then 
      CALL HF1(2002,SHWDET(2002),1.)
      endif
      IF(SHWDET(2003).gt.0) then 
      CALL HF1(2003,SHWDET(2003),1.)
      endif
      IF(SHWDET(2004).gt.0) then 
      CALL HF1(2004,SHWDET(2004),1.)
      endif
C
C
C     If total energy deposited is > 0 then ...
C
      if(EDTTSW.GT.0.00000)then
C
        CALL HF1(2,1000.*EDTTSW,1.)
C
      endif                              ! total en. dep. in LG > 0.
C
C
      RETURN
      END
C.
C
C.........
C
C
C
C.**************************************************************************
*____ Author :A. Gasparian                                                 *
*____ date : 8/23/94                                                       *
*                                                                          *
C.    *                                                                    *
C.    *      Termination routine to print histograms and statistics        *
C.    *                                                                    *
*                                                                          *
C.**************************************************************************
C
      SUBROUTINE UGLAST
C
C
      CALL GLAST
C
      CALL HROUT(0,ICYCLE,' ')
      CALL HREND('HBOOK')
C
C
      RETURN
      END
C.
C......
C.
C
C.**************************************************************************
*____ Author :A. Gasparian                                                 *
*____ date : 8/15/94                                                       *
*                                                                          *
C.    *                                                                    *
C.    *         Draw full set up in 'view bank' mode.                      *
C.    *                                                                    *
*                                                                          *
C.**************************************************************************
C
      SUBROUTINE HBVIEW
C
C
      CALL GSATT('*','SEEN', 1)
      CALL GSATT('HALB','SEEN', 0)
C
C
C             Create bank for view of hall a setup
C
C
      CALL GSATT('TTSW','COLO', 4)
C
      CALL GDOPEN(1)
      CALL GDRAW ('HALB',90.,90.,0.,1.,10.,0.024,0.024)
      CALL GDCLOS
C                         Y scale 3 times bigger than X
      CALL GDOPEN(2)
      CALL GDRAW ('HALB',90.,90.,0.,1.,10.,0.024,0.072)
      CALL GDCLOS
C
      CALL GDOPEN(3)
      CALL GDRAW ('HALB',90.,90.,0.,1.,10.,0.02,0.5)
      CALL GDCLOS
C
      CALL GDOPEN(11)
      CALL GDRAW ('HALB',135.,145.,0.,1.5,3.,0.032,0.032)
      CALL GDCLOS
C
      CALL GDOPEN(12)
      CALL GDRAW ('HALB',135.,125.,0.,1.5,1.5,0.04,0.04)
      CALL GDCLOS
C
      CALL GDOPEN(21)
      CALL GDRAWC('HALB',3,750.,10.0,10.0,0.15,0.15)
      CALL GDCLOS
C
      CALL GDOPEN(22)
      CALL GDRAWC('HALB',3,500.,10.0,10.0,0.15,0.15)
      CALL GDCLOS
C
      CALL GDOPEN(23)
      CALL GDRAWC('HALB',3,400.,10.0,10.0,0.15,0.15)
      CALL GDCLOS
C
      CALL GDOPEN(24)
      CALL GDRAWC('HALB',3,20.,10.0,10.0,0.15,0.15)
      CALL GDCLOS
C
C                                                      be careful all uncolor
CC      CALL GSATT('*','COLO', 1)
      CALL GSATT('*','LSTY', 1)
C
C
      RETURN
      END
C
C.
C...
C.
C
C












