C
C.*************************************************************************
*-- DATE  : 12/27/96                                                      *
*-- Author: A. Gasparian                                                  *
*                                                                         *
C ***          Define MATERIALS                                           *
C                                                                         *
*                                                                         *
C                                                                         *
C                                                                         *
C    Modified 6/18/98 by D. Lawrence
C
C.*************************************************************************
C
      SUBROUTINE GUMAT
C
C
      PARAMETER (KWBANK=69000,KWWORK=5200)
      CHARACTER*20 NA
      COMMON/GCBANK/NZEBRA,GVERSN,ZVERSN,IXSTOR,IXDIV,IXCONS,FENDQ(16)
     +             ,LMAIN,LR1,WS(KWBANK)
      DIMENSION IQ(2),Q(2),LQ(8000),IWS(2)
      EQUIVALENCE (Q(1),IQ(1),LQ(9)),(LQ(1),LMAIN),(IWS(1),WS(1))
      EQUIVALENCE (JCG,JGSTAT)
      COMMON/GCLINK/JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
C
      COMMON/PVOLUM/ NL,NR,IMAT,XO
C
      DIMENSION Z(6),A(6),WMAT(6),UBUF(6)
      DIMENSION ZLG(6),ALG(6),WLG(6)
      DIMENSION AF(3),ZF(3),WMATF(3)
      DIMENSION AWATER(2),ZWATER(2),WWATER(2)
      DIMENSION ASCI(2),ZSCI(2),WSCI(2)
      DIMENSION APYR(4),ZPYR(4),WPYR(4)
      DIMENSION APOL(2),ZPOL(2),WPOL(2)
      DIMENSION ALUC(3),ZLUC(3),WLUC(3)
      DIMENSION APBGL(3),ZPBGL(3),WPBGL(3)
      DIMENSION AMYL(3),ZMYL(3),WMYL(3)

      DATA APYR,ZPYR,WPYR/28.09,10.82,23.0,16.0,14.0,5.,11.,8.,
     +0.385,0.039,0.038,0.538/
      DATA APOL,ZPOL,WPOL/12.01,1.01,6.0,1.0,1.0,2.0/
      DATA ALUC,ZLUC,WLUC/12.01,1.01,16.0,6.0,1.0,8.0,5.0,5.0,2.0/
      DATA APBGL,ZPBGL,WPBGL/208.0,16.0,28.0,82.0,8.0,14.0,15.,127.,56./
C
C
C             Water compound parameters
C
      DATA AWATER/1.,16./
      DATA ZWATER/1.,8./
      DATA WWATER/2.,1./
C
C             Lead glass mixture parameters
C
      DATA ZLG/  82.00,  19.00,  14.00,  11.00,  8.00,  33.00/
      DATA ALG/ 207.19,  39.102,  28.088,  22.99, 15.999,  74.922/
      DATA WLG/ .65994, .00799, .126676, .0040073,.199281, .00200485/
C
C             Iron+Nickel+Crome  compound parameters
C
      DATA AF/55.847,58.71,51.998/
      DATA ZF/26.,28.,24./
      DATA WMATF/0.703964,0.099,0.197/
C
C             Scintillator
C
      DATA ASCI/12.01,1.01/
      DATA ZSCI/6.,1./
      DATA WSCI/1.,2./
      DATA DSCI/1.032/
C
C             Mylar
C
      DATA AMYL/12.011,1.00794,15.9994/
      DATA ZMYL/6.,1.,8./
      DATA WMYL/5.,4.,2./

C
C ********  GEANT STANDARD MATERIALS    **********
C
      CALL GMATE           ! geant default materials  #1-16
C
C	 1 Hydrogen		 9 Aluminum
C	 2 Deuterium		10 Iron
C 	 3 Helium		11 Copper
C	 4 Lithium		12 Tungsten
C	 5 Beryllium		13 Lead
C	 6 Carbon		14 Uranium
C	 7 Nitrogen		15 Air
C	 8 Neon			16 Vacuum
C
C
C         ADDITIONAL ALIUMINIUM FOR DEFFERENT CUT LEVEL                 #17
      CALL GSMATE(17,'SECOND ALUMIN$',26.98,13.00,2.7,8.9,0.,0.,0)
C
C         ADDITIONAL  IRON  FOR DEFFERENT CUT LEVEL                     #18
      CALL GSMATE(18,'SECOND IRON  $',55.85,26.00,7.87,1.76,0.,0.,0)
C
C..       ADDITIONAL  VACUUM FOR DEFFERENT CUT LEVEL                   #19
      CALL GSMATE(19,'SECOND VACUUM$',1.E-16,1.E-16,1.E-16,1.E16
     *,0.,0.,0)
C..                                                                    #20
      CALL GSMIXT(20,'IRON(COMPOUND)$',AF,ZF,7.8,3,WMATF)
C
      CALL GSMIXT(22,'LEAD GLASS$',ALG,ZLG,5.2,6,WLG)                ! #22 SF-6
C..                                                                     #23
      CALL GSMATE(23,'PLAST SC$',  6.25,3.4,1.032 ,   43.0,   437.,0.,0)
      CALL GSMIXT(24,'SCINTILLATOR$',ASCI,ZSCI,DSCI,-2,WSCI)          !#24 SCIN
C..                                                                     #26
      CALL GSMIXT(26,'Water$$',AWATER,ZWATER,1.,-2,WWATER)
C
C..          IRON for Moller target                                     # 27
      CALL GSMATE(27,'MOLLER IRON  $',55.85,26.00,7.87,1.76,0.,0.,0)
C
C..          Second LEAD for Dipole Collimator                          # 28
      CALL GSMATE(28,'LEAD COLLIM. $',207.190,82.00,11.35,0.56,0.,0.,0)
C
C..          Thierd LEAD for Detector Shielding                         # 29
      CALL GSMATE(29,'LEAD SHIELD. $',207.190,82.00,11.35,0.56,0.,0.,0)
C
C..          Fourt  LEAD for Prim. Real Target                          # 82
C
      CALL GSMATE(82,'Pr.RealLeadT.$',207.190,82.00,11.35,0.56,0.,0.,0)
C
C..          Fift LEAD for Primakov Target                              # 81
C
C   For correct calculation the density and RL are DECREASED 10 TIME
C        So, the TARGET LENGTH should be x10 TIME
C
      CALL GSMATE(81,'LEAD TARGET $',207.190,82.00,1.135,0.056,0.,0.,0)
C
C               Second Mylar for Zoh's Window                           # 30
      CALL GSMIXT(30,'ZOHs MYLAR$              ',
     +                AMYL,ZMYL,1.39,-3,WMYL)
C
C
      CALL GSMATE(31,'CALCIUM$            ',
     +                40.08,20.,1.55,10.4,23.2,0.,0)
      CALL GSMATE(32,'GOLD$               ',
     +                196.9665,79.0,19.3,0.335,0.0,UBUF,0)
      CALL GSMATE(33,'OXYGEN$             ',
     +                16.0,8.0,1.14,28.7,0.0,UBUF,0)
      CALL GSMATE(34,'SILICON$            ',
     +                28.09,14.0,2.33,9.36,0.0,UBUF,0)
      CALL GSMATE(35,'ARSENIC$            ',
     +                74.92,33.0,5.73,2.1,0.0,UBUF,0)
      CALL GSMATE(36,'SODIUM$             ',
     +                22.99,11.0,0.971,28.5,0.0,UBUF,0)
      CALL GSMATE(37,'POTASSIUM$          ',
     +                39.1,19.0,0.862,20.1,0.0,UBUF,0)
C
C.*******      DEFFERENT USEFUL MATERIALS
C
      CALL GSMIXT(41,'MYLAR$              ',
     +                AMYL,ZMYL,1.39,-3,WMYL)
      CALL GSMIXT(42,'PAREX$              ',
     +                APYR,ZPYR,2.23,4,WPYR)
      CALL GSMIXT(45,'POLYETHYLENE$       ',
     +                APOL,ZPOL,0.935,-2,WPOL)
C 
C.*****        Create various chemical compounds from the elements  ** oxide
C.      QUARTZ (Silicon oxide)
      CALL GFMATE(34, NA, A(1), Z(1), D, R, AB, UBUF, NW)  ! silicon
      CALL GFMATE(33, NA, A(2), Z(2), D, R, AB, UBUF, NW)  ! oxigen
      WMAT(1)= 1.0
      WMAT(2)= 2.0
      CALL GSMIXT(51,'QUARTZ$            ',
     +                A, Z, 2.2, -2, WMAT)                     ! SiO2    #51
C *** LEAD OXIDE  
      CALL GFMATE(13, NA, A(1), Z(1), D, R, AB, UBUF, NW)  !   LEAD
      WMAT(1)= 1.0
      WMAT(2)= 1.0
      CALL GSMIXT(52,'LEAD OXIDE$        ',
     +                A, Z, 9.53, -2, WMAT)                     ! PbO    #52
C ** POTASSIUM OXIDE
      CALL GFMATE(37, NA, A(1), Z(1), D, R, AB, UBUF, NW)  
      WMAT(1)= 2.0
      WMAT(2)= 1.0
      CALL GSMIXT(53,'POTASSIUM OXIDE$  ',
     +                A, Z, 2.32, -2, WMAT)                     ! K2O    #53
C ** SODIUM OXIDE
      CALL GFMATE(36, NA, A(1), Z(1), D, R, AB, UBUF, NW)  
      WMAT(1)= 2.0
      WMAT(2)= 1.0
      CALL GSMIXT(54,'SODIUM OXIDE$      ',
     +                A, Z, 2.27, -2, WMAT)                     ! Na2O    #54
C ** ARSENIC OXIDE
      CALL GFMATE(35, NA, A(1), Z(1), D, R, AB, UBUF, NW)  
      WMAT(1)= 2.0
      WMAT(2)= 3.0
      CALL GSMIXT(55,'ARSENIC OXIDE$    ',
     +                A, Z, 3.738, -2, WMAT)                     ! As2O3    #55
C **  LEAD GLASS TF-1
      CALL GFMATE(52, NA, A(1), Z(1), D, R, AB, UBUF, NW)  !PbO
      CALL GFMATE(51, NA, A(2), Z(2), D, R, AB, UBUF, NW)  !SiO2
      CALL GFMATE(53, NA, A(3), Z(3), D, R, AB, UBUF, NW)  !K2O
      CALL GFMATE(54, NA, A(4), Z(4), D, R, AB, UBUF, NW)  !Na2O
      CALL GFMATE(55, NA, A(5), Z(5), D, R, AB, UBUF, NW)  !Ar2O3
      WMAT(1)= 50.8E-02     !PbO
      WMAT(2)= 41.7E-02     !SiO2
      WMAT(3)= 4.22E-02     !K2O
      WMAT(4)= 2.78E-02     !Na2O
      WMAT(5)= 0.50E-02     !As2O3
      CALL GSMIXT(61,'LEAD GLASS TF-1$    ',                   !           # 61
     +                A, Z, 3.86, 5, WMAT)                     !LEAD GLASS TF-1
C
C ****  LEAD GLASS SF-5
      WMAT(1)= 55.0E-02     !PbO
      WMAT(2)= 38.0E-02     !SiO2
      WMAT(3)=  5.0E-02     !K2O
      WMAT(4)=  1.5E-02     !Na2O
      WMAT(5)=  0.5E-02     !As2O3
      CALL GSMIXT(62,'LEAD GLASS SF-5$     ',                  !           # 62
     +                A, Z, 4.08, 5, WMAT)                     !LEAD GLASS SF-5
C
C **  LEAD Tungstenate
      CALL GFMATE(13, NA, A(1), Z(1), D, R, AB, UBUF, NW)  !Pb
      CALL GFMATE(12, NA, A(2), Z(2), D, R, AB, UBUF, NW)  !W
      CALL GFMATE(33, NA, A(3), Z(3), D, R, AB, UBUF, NW)  !O
      WMAT(1)= 1            !Pb
      WMAT(2)= 1            !W
      WMAT(3)= 4            !O
      CALL GSMIXT(63,'PbWO4$    ',                             !           # 63
     +                A, Z, 8.28, -3, WMAT)                     !PbWO4
C
C *** Heptane Gas C7H14
      CALL GFMATE(6, NA, A(1), Z(1), D, R, AB, UBUF, NW)  !   Carbon
      CALL GFMATE(1, NA, A(2), Z(2), D, R, AB, UBUF, NW)  !   Hydrogen
      WMAT(1)= 7.0
      WMAT(2)= 14.0
      CALL GSMIXT(64,'Heptane Gas$',A, Z, 0.00548, -2, WMAT) ! Heptane gas # 64

C
      PRINT*, '====================================================='
      PRINT*, '====================================================='
      PRINT*, '             Finished defining materials !!!      '
      PRINT*, '====================================================='
      PRINT*, '====================================================='
      RETURN
      END
C.
