

#include <operators.h>


Complex IMAGINARY=Complex(0.0,1.0);

/**********************************************/
/* Overloading +,-,*,/ operators for complex  */
/* numbers.                                   */
/**********************************************/

Complex operator+(Complex a, Complex b)
{
   return Complex( a.R + b.R , a.I + b.I );
}

Complex operator-(Complex a, Complex b)
{
   return Complex( a.R - b.R , a.I - b.I );
}

Complex operator*(Complex a, Complex b)
{
   return Complex( (a.R*b.R)-(a.I*b.I) , (a.R*b.I)+(a.I*b.R) );
}

Complex operator/(Complex a, Complex b)
{
   double r2;
   
   r2=(b.R*b.R)+(b.I*b.I);
   
   return Complex( ((a.R*b.R)+(a.I*b.I))/r2 , ((a.I*b.R)-(a.R*b.I))/r2 );
}

Complex operator-(Complex a)
{
   return Complex( -a.R,-a.I );
}



/**********************************************/
/* Creation operators for Complex numbers     */
/**********************************************/
Complex::Complex()
{
   R=0.0;
   I=0.0;
}

Complex::Complex(double r)
{
   R=r;
   I=0;
}

Complex::Complex(double r,double i)
{
   R=r;
   I=i;
}

/**********************************************/
/* Other Misc Complex number routines         */
/**********************************************/
double Complex::Magnitude()
{
   return sqrt((R*R) + (I*I));
}


Complex exp(Complex c)
{
   return exp(c.R)*Complex(cos(c.I),sin(c.I));
   
}



/**********************************************/
/* Overloading +,-,*,/ operators for Vect3    */
/* and Vect4 vectors.                         */
/**********************************************/
Vect3 operator+(Vect3 a, Vect3 b)
{ return Vect3( a.px+b.px, a.py+b.py, a.pz+b.pz ); }

Vect3 operator-(Vect3 a, Vect3 b)
{ return Vect3( a.px-b.px, a.py-b.py, a.pz-b.pz ); }

double operator*(Vect3 a, Vect3 b)
{ return ((a.px+b.px) + (a.py*b.py) + (a.pz*b.pz) ); }

Vect3 operator-(Vect3 a)
{ return Vect3( -a.px , -a.py , -a.pz ); }


Vect4 operator+(Vect4 a, Vect4 b)
{ return Vect4( a.E+b.E , a.px+b.px, a.py+b.py, a.pz+b.pz ); }

Vect4 operator-(Vect4 a, Vect4 b)
{ return Vect4( a.E-b.E , a.px-b.px, a.py-b.py, a.pz-b.pz ); }

double operator*(Vect4 a, Vect4 b)
{ return ((a.E*b.E) -  (a.px+b.px) - (a.py*b.py) - (a.pz*b.pz) ); }

Vect4 operator-(Vect4 a)
{ return Vect4( -a.E , -a.px , -a.py , -a.pz ); }






