


#include "psim.h"

trig_rate_t trig_rate;
float max_energy,pos_of_Emax[3];

int Npart_infos;
part_info_t part_info[max_part_infos];
part_info_t pi0_gammas[2];

float pair_e_X,pair_e_Y,pair_p_X,pair_p_Y;
float phot_1_X,phot_1_Y,phot_2_X,phot_2_Y;


void gustep_(void)
{
   int i, ICOP;
   int HID;
   int   INWVOL   = gctrak_.inwvol;
   float SLENG    = gctrak_.sleng;
   int   NMEC     = gctrak_.nmec;
   int  *LMEC     = gctrak_.lmec;
   char *NAMEC    = (char*)gctrak_.namec;
   int   NLEVEL   = gcvolu_.nlevel;
   char *VNAMES   = gcvolu_.names;
   int  *VNUM     = gcvolu_.number;
   int   IDTYPE   = gcsets_.idtype;
   int  *NUMBV    = gcsets_.numbv;
   float *SHWDET  = cheren_.shwdet;
   float *TSHWDET = cheren_.tshwdet;
   float DESTEP   = gctrak_.destep;
   float TOFG     = gctrak_.tofg;
   float *pos     = gctrak_.vect;
   float GETOT    = gctrak_.getot;
   int   IPART    = gckine_.ipart;
   int   *ISTOP   =&gctrak_.istop;
   float CHARGE   = gckine_.charge;
   float alpha=0.0,x,y,pmom[3],ptot;
   float *VERT		= gckine_.vert;
   int   ITRA		= gckine_.itra;
   
   static unsigned int cntr=0;
   
   static float X,Y,Z,X0,Y0,R,PHI;
   static float phi,cos_phi,sin_phi;
   static int phot1_track;
   char mech_str[5]="none";
   float a,b;
   
   
   /**************************************************************/
   /* Energy depositions are stored in the global array SHWDET[] */
   /* The initial hit times are stored in the global array       */
   /* TSHWDET[]. Most other information about particles hitting  */
   /* the calorimeter are stored in the array of part_info data  */
   /* structures. This information is processed at the end of the*/
   /* event when the histograms are filled.                      */
   /**************************************************************/

   /* make sure there's a particle to track */
   if(IPART<=ptype_none){printf("NO PARTICLE TO TRACK!!  event=%d\n",IEVENT);return;}

   /* Draw track if flag is set */
   if(track_flags[draw_track]){
      if(GETOT>0.050){
         if(((cntr++)%1) == 0){
            if(!(flags[dont_draw_charged_tracks] && CHARGE)){
               if(!(flags[dont_draw_neutral_tracks] && !CHARGE)){
                  if((pos[2]-thargt_.thrpos[2])>-30){
                     gsxyz_();
                     gdxyz_(&zero);
                  }
               }
            }
         }
      }
   }

	/* see note in GENERATORS/pairs.c */
	if(flags[pair_produce]){

		flags[pair_produce]=0;
		if(IPART!=ptype_gamma || initial_4vect.E!=GETOT){
			*ISTOP=2;
			return;
		}
		
		gctrak_.nmec=1;
		gctrak_.lmec[0]=6;
		strncpy((char*)&gctrak_.namec[0],"PAIR",4);
		gpairg_();
		gsking_(&zero);

		return;
	}
   
   /*printf("ptype=%d  ID=%d  x=%3.0f y=%3.0f z=%3.0f\n"
      ,IPART,VNUM[NLEVEL-1] ,pos[0],pos[1],pos[2]);*/

   /**************************************************************/
   /* Remember position of electron/positron pairs at front face */
   /* of calorimeter.                                            */
   /**************************************************************/
   if((pos[2]>=newdet_.pi0d[2]) && ((VERT[2]-thargt_.thrpos[2])<1.0)){
      if(pair_e_X ==-10000.0 && pair_e_Y==-10000.0 && IPART==ptype_electron){
         pair_e_X=pos[0];
         pair_e_Y=pos[1];
      }else if(pair_p_X ==-10000.0 && pair_p_Y==-10000.0 && IPART==ptype_positron){
         pair_p_X=pos[0];
         pair_p_Y=pos[1];
      }else if(phot_1_X ==-10000.0 && phot_1_Y==-10000.0 && IPART==ptype_gamma){
         phot_1_X=pos[0];
         phot_1_Y=pos[1];
         phot1_track=ITRA;
      }else if(phot_2_X ==-10000.0 && phot_2_Y==-10000.0 && IPART==ptype_gamma && ITRA!=phot1_track){
         phot_2_X=pos[0];
         phot_2_Y=pos[1];
      }
   }


   /* stop tracking if we hit the magnet far from end */
   if(VNUM[NLEVEL-1]==3001){
      a=pos[2]-posito_.posit[0]; /* z position relative to magnet center*/
      b=45.72; /* half length of magnet in z direction */
      if((b-a) > 10.0 ){
         *ISTOP=2;
         return;
      }
   }
   
   /* stop tracking charged particles which have no chance */
   /* of getting out of the magnet                         */
   if( VNUM[NLEVEL-1]==3000 || VNUM[NLEVEL-1]==3001){
      a=pos[2]-posito_.posit[0]; /* z position relative to magnet center*/
      /* if this is a neutral particle, check if is has the full   */
      /* initial photon energy and is past the target. if so, then */
      /* it is probably the incident photon which did not interact */
      /* with the target so we can stop tracking it.               */
      if(CHARGE==0.0){
         if(pos[2]-thargt_.thrpos[2]>1.0 && initial_photon_energy==GETOT){
            *ISTOP=2;
            return;
         }
      }else{
         if(a<-10.0 && GETOT<0.700){
/*            *ISTOP=2;
            return;
*/
         }
      }
   }
   

   /****************************************************************/
   /* Try and record info just about the two gammas from pi0 decay */
   /* Look for the pi0 and the creation of two secondaries.        */
   /* Use the photon momenta to project them to the surface of the */
   /* calorimeter.                                                 */
   /****************************************************************/
   /* need to check this BEFORE calling gsking() */
   if(IPART==ptype_pion_zero && gcking_.ngkine==2){
#define GKIN gcking_.gkin
#define GPOS gckin3_.gpos
   
      pmom[0]=GKIN[0][0];  pmom[1]=GKIN[0][1];  pmom[2]=GKIN[0][2];
      ptot=sqrt( pmom[0]* pmom[0] +  pmom[1]* pmom[1] + pmom[2]* pmom[2]);
      if(ptot>0.0){
         pmom[0]/=ptot;
         pmom[1]/=ptot;
         pmom[2]/=ptot;
      }
      alpha= pmom[2]==0.0 ? 1.0E6:(newdet_.pi0d[2]-GPOS[0][2])/pmom[2];
      pi0_gammas[0].E=GKIN[0][3];
      pi0_gammas[0].X=GPOS[0][0]+(alpha*pmom[0]);
      pi0_gammas[0].Y=GPOS[0][1]+(alpha*pmom[1]);
      pi0_gammas[0].Z=GPOS[0][2]+(alpha*pmom[2]);
      pi0_gammas[0].T=TOFG;
      pi0_gammas[0].p=ptot;
      pi0_gammas[0].type=IPART;
      if(debug>1)if(alpha<0.0)printf("pi0:alpha1=%g\n",alpha);

      pmom[0]=GKIN[1][0];  pmom[1]=GKIN[1][1];  pmom[2]=GKIN[1][2];
      ptot=sqrt( pmom[0]* pmom[0] +  pmom[1]* pmom[1] + pmom[2]* pmom[2]);
      if(ptot>0.0){
         pmom[0]/=ptot;
         pmom[1]/=ptot;
         pmom[2]/=ptot;
      }
      alpha= pmom[2]==0.0 ? 1.0E6:(newdet_.pi0d[2]-GPOS[1][2])/pmom[2];
      pi0_gammas[1].E=GKIN[1][3];
      pi0_gammas[1].X=GPOS[1][0]+(alpha*pmom[0]);
      pi0_gammas[1].Y=GPOS[1][1]+(alpha*pmom[1]);
      pi0_gammas[1].Z=GPOS[1][2]+(alpha*pmom[2]);
      pi0_gammas[1].T=TOFG;
      pi0_gammas[1].p=ptot;
      pi0_gammas[1].type=IPART;
      if(debug>1)if(alpha<0.0)printf("pi0:alpha2=%g\n",alpha);
      
   }

   /* check that we're in a detector */
   if(IDTYPE==0){
      gsking_(&zero);
      return;
   }

  
   /*************************************************************/
   /* ICOP is the detector number (   1 to  729  for lead glass */
   /*                              1001 to 1484  for insertion  */
   /*                              2001 to 2032 for pair cntr)  */
   /* For eta:                                                  */
   /*            1 to 1225 for lead glass                       */
   /*                 2047 for target                           */
   /*************************************************************/
   ICOP = NUMBV[0];
   
   /******************************************************************/
   /* Add the energy deposited this step to the appropriate detector */
   /* and push the secondaries onto the stack for tracking.          */
   /* Also record the time if this is the first time this detector   */
   /* is hit this event.                                             */
   /******************************************************************/
   if( ICOP<2048 && ICOP>0){
   
      SHWDET[ICOP] += DESTEP;
      if(ICOP<2000)nascom_.edttsw+=DESTEP;
      
      /* Time at which calorimeter is first hit */
      if(TSHWDET[ICOP]==0.0){
         TSHWDET[ICOP]=TOFG;
      }
      
   }
   /***********************************************************/
   /* For every particle above the specified energy threshold */
   /* which hit the calorimeter, record the info about the    */
   /* particle.                                               */
   /* INWVOL==1 : track is entering a new volume or is a new  */
   /* track. SLENG is the track length and is 0.0 for new     */
   /* tracks. The test on SLENG is put on 1.5 meters to avoid */
   /* recording info as tracks enter/leave the dipole and     */
   /* target.                                                 */
   /***********************************************************/
   if( INWVOL==1 && SLENG>150.0 && GETOT>0.1 && ICOP<2000 && ICOP>0){
   
      if(debug>1)printf("\n%d:x=%4.1f y=%4.1f z=%4.1f  GETOT=%4.3f SLENG=%f ICOP=%d"
         ,IEVENT,pos[0],pos[1],pos[2],GETOT,SLENG,ICOP);
   
      pmom[0]=GKIN[1][0];  pmom[1]=GKIN[1][1];  pmom[2]=GKIN[1][2];
      ptot=sqrt( pmom[0]* pmom[0] +  pmom[1]* pmom[1] + pmom[2]* pmom[2]);
      if(ptot>0.0){
         pmom[0]/=ptot;
         pmom[1]/=ptot;
         pmom[2]/=ptot;
      }

      track_flags[calorimeter_hit]=1;      
      
      if(Npart_infos < max_part_infos){
         part_info[Npart_infos].X=pos[0];
         part_info[Npart_infos].Y=pos[1];
         part_info[Npart_infos].Z=pos[2];
         part_info[Npart_infos].PX=pmom[0];
         part_info[Npart_infos].PY=pmom[1];
         part_info[Npart_infos].PZ=pmom[2];
         part_info[Npart_infos].E=GETOT;
         part_info[Npart_infos].T=TOFG;
         part_info[Npart_infos].p=pos[6];
         part_info[Npart_infos].type=IPART;
         Npart_infos++;
      }else {
         printf("Too many particles above threshold are hitting calorimeter!(z=%f)\n",fabs(pos[2]-newdet_.pi0d[2]));
      }
   }
   
   /* if calorimeter was hit, record energy deposition as func of x,y */
   if(ICOP <2000 && DESTEP!=0.0 && track_flags[calorimeter_hit]!=0){
      HID=1100;
      X=pos[0]-X0;
      Y=pos[1]-Y0;
      hfill_(&HID,&X,&Y,&DESTEP);
   }
   
   /*-------------- Track all secondary particles -------------------*/
	if(flags[stop_at_calorimeter]){
		if(pos[2]>newdet_.pi0d[2]+1.0){
			*ISTOP=1;
			SHWDET[ICOP] += GETOT;
		}
	}
   if(*ISTOP==0)gsking_(&zero);
   
}










