

#include "../common.h"

#define E_thresh 0.0


int flags[num_flags+1];


/* called by GUTREV at begining of event */
void gukinec_(void)
{
   int i;
   static long last_time=0L;
   int *ISWIT = gcflag_.iswit;
   
   /* reset flags */
   for(i=0;i<num_flags;i++)flags[i]=0;
   
   /* reset subsets */
   for(i=0;i<nsets;i++){
      sets[i]->HITS = 0  ;
      sets[i]->E    = 0.0;
      sets[i]->T    = 0.0;
   }
   
   /* If ISWIT(1) is greater than 1, draw track every ISWIT(1) seconds */
   if(ISWIT[0]==1)flags[draw_track]=1;
   if(ISWIT[0]>1)
      if(time(NULL)-last_time>ISWIT[0]){
         last_time=time(NULL);
         flags[draw_track]=1;
      } 
}

void gustepc_(void)
{
   int i;
   
   int   NMEC   = gctrak_.nmec;
   int  *LMEC   = gctrak_.lmec;
   char *NAMEC  = (char*)gctrak_.namec;
   int   NLEVEL = gcvolu_.nlevel;
   char *VNAMES = gcvolu_.names;

   /* check if certain mechanisms are present */
   for(i=0;i<NMEC;i++){
      if(LMEC[i]==6){
         flags[pair_prod]=1;
         /* Check if we're in the target */
         if(strstr(VNAMES,"PTRG"))flags[pair_prod_in_tgt]=1;
      }
   }
   
   /* Draw track if flag is set */
   if(flags[draw_track]){
      gsxyz();
      gdxyz(0);
   }
   
}

void guoutc_(void)
{
   int i,j;
   subset *s;
   static long start_time=0L,last_time;
   float delta_events,delta_time;
   int something_hit=0;
   
   /* update screen info */
   if(start_time==0L)start_time=last_time=time(NULL);
   if(time(NULL)-last_time>=2L){      
      delta_events=(float)gcflag_.ievent;
      delta_time=(float)(time(NULL)-start_time);
      printf("%ld events processed. (%f sec/event  %f events/sec)       \r"
         ,(long)gcflag_.ievent
         ,delta_time/delta_events
         ,delta_events/delta_time);
      
      fflush(stdout);
      last_time=time(NULL);
   
      /* If running in batch mode, decide if we should quit */
      if(BATCH){
         if(run_time>0.0)
            if((double)(time(NULL)-start_time)>=3600.0*run_time)quit=1;
            if(quit)IEORUN=1;
      }
   }
   if(BATCH!=0 && N_EVENT==0L)NEVENT=IEVENT+2;

   
   /* Pair Detection */
   if((SHWDET[2001]>0.0 || SHWDET[2002]>0.0)
      && (SHWDET[2003]>0.0 || SHWDET[2004]>0.0))printf("\n**              PAIR DETECTED           **\n\n");
      
   /* fill subsets data structure */
   for(j=0;j<nsets;j++){
      s=sets[j];
      s->HITS=0;
      s->T=1.0E10;
      s->E=0.0;
      for(i=0;i<s->Num;i++){
         /* sparsely fill arrays only with detectors that have energy */
         if(SHWDET[s->list[i]] > E_thresh){
            s->Eelem[s->HITS] = SHWDET[s->list[i]];
            s->Telem[s->HITS] = TSHWDET[s->list[i]];
         
            /* add to total energy of set */
            s->E+=s->Eelem[s->HITS];
            
            /* use time of first detector hit for time of set */
            if(s->Telem[s->HITS]<s->T)s->T=s->Telem[s->HITS];
            
            s->HITS++;
            something_hit=1;
         }
      }
   }
   
   /* add the event to the Ntuple */
/*   if(flags[pair_prod])printf("\n****** PAIR PRODUCED ******\n\n");*/
   if(something_hit)hfnt(nt1);

}



