

#include "psim.h"


int T3_Ngroups;


void DefineGroups3(void);



/**********************************************/
/* Initialize stuff for the trigger simulator */
/**********************************************/
void init_trigger3(void)
{
   /* Linear Fan-in Groups */
   DefineGroups3();
   
}


/************************************************************/
/* Define Group subsets. A "group" here represents a group  */
/* of detectors added together in a UVa120 linear fan-in.   */
/* Some groups will be added together in UVa125 adder/      */
/* discriminator modules. This is done in trigger() below.  */
/************************************************************/
void DefineGroups3(void)
{
   int i,j;
   char str[256];
   int M=0;
   int x,y,dx,dy;
   
   dx=dy=6;
   
   printf("Defining groups for trigger 3\n");
   
   /* outer */
   for(j=0;j<6;j++){
      for(i=0;i<6;i++){
         x=(i*5) + 1;
         y=(j*5) + 1;
      
         sprintf(str,"T3G%d",++M);
         AddBlockToSubset(AddSubset(str),x,y,dx,dy,0);
         
      }
   }

   /* inner */
   for(j=0;j<5;j++){
      for(i=0;i<5;i++){
         x=(i*5) + 1;
         y=(j*5) + 1;
      
         sprintf(str,"T3G%d",++M);
         AddBlockToSubset(AddSubset(str),x,y,dx,dy,1);
         
      }
   }

   T3_Ngroups=M;
}




int trigger3(float Ethresh)
{
   int i,N=0;
   char str[256];
   
   for(i=0;i<T3_Ngroups;i++){
      sprintf(str,"T3G%d",i+1);
      if(FindSubset(str)->E>Ethresh)N++;
   }
   
   
   return N>1;
}









