
/****************************************************************/
/* kinematics.h                                                 */
/*                                                              */
/* Some basic kinematics routines and tools                     */
/*                                                              */
/* D. Lawrence                                                  */
/* 3/18/99                                                      */
/****************************************************************/


#include <math.h>


/* vertex array */
typedef struct{
   float x,y,z;
}myvertex_t;
extern myvertex_t myvertex_;

/* four vector */
typedef struct{
   float E;
   float x,y,z;
}vect4;



/* Routines */
vect4 vect4_add(vect4 v1,vect4 v2);
vect4 vect4_sub(vect4 v1,vect4 v2);
float vect4_mul(vect4 v1,vect4 v2);
float vect4_sq(vect4 v);
vect4 vect4_boost(vect4 p,float beta);
char* part_type_str(int type);
int chargeof(int type);