

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdiostream.h>
#include <iostream.h>
#include <strstream.h>
#include <iomanip.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <time.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <signal.h>


class Complex {

   public:
      double R;
      double I;

      Complex();
      Complex(double r);
      Complex(double r, double i);
      
      double Magnitude();
      Complex Conjugate(){return Complex(R,-I);}
      
      friend Complex operator+(Complex,Complex);
      friend Complex operator-(Complex,Complex);
      friend Complex operator*(Complex,Complex);
      friend Complex operator/(Complex,Complex);
      friend Complex operator-(Complex);
      friend Complex exp(Complex);
};


// Global variable for "i"
extern Complex IMAGINARY;

class Vect3 {

   public:
      double px,py,pz;
      
      Vect3(){px=0.0; py=0.0; pz=0.0;}
      Vect3(double p_z){px=0.0; py=0.0; pz=p_z;}
      Vect3(double p_x, double p_y, double p_z){px=p_x; py=p_y;pz=p_z;}

      double p2(){return (px*px)+(py*py)+(pz*pz);}
      double p(){return sqrt(p2());}
      
      friend Vect3  operator+(Vect3,Vect3);
      friend Vect3  operator-(Vect3,Vect3);
      friend double operator*(Vect3,Vect3);
      friend Vect3  operator-(Vect3);

};

class Vect4: public Vect3 {

   public:
      double E;

      Vect4():Vect3(){E=0.0;}
      Vect4(double e):Vect3(){E=e;}
      Vect4(double e,double p_z):Vect3(p_z){E=e;}
      Vect4(double e,double p_x,double p_y,double p_z):Vect3(p_x,p_y,p_z){E=e;}
   
      double Mass(){return sqrt((E*E)-p2());}
		double Mass2(){return ((E*E)-p2());}
       void Print(char* mess){
         if(mess)cerr<<mess;
         cerr<<"("<<E<<","<<px<<","<<py<<","<<pz<<")\n";
      }
      
   
      friend Vect4  operator+(Vect4,Vect4);
      friend Vect4  operator-(Vect4,Vect4);
      friend double operator*(Vect4,Vect4);
      friend Vect4  operator-(Vect4);
};






