




#include "psim.h"


#define Ethresh 0.0


typedef struct {
   int   index;
   float limit;
}cut_t;
cut_t cut_lt[100];
cut_t cut_gt[100];
cut_t cut_eq[100];
int N_cut_lt=0,N_cut_gt=0,N_cut_eq=0;


char outfname[256]="",infname[128][256];
int Ninfiles=0;
FILE *outfile;
int quit_program=0;
int need_to_check_triggers=0;
int check_trig1=0,check_trig2=0,check_trig3=0,check_trig4=0;

char val_types[128][20]={"event","type","Ephoton","Edeposited",
      				"initialE","initialPx","initialPy","initialPz",
                  "initialR","initialX","initialY","initialZ",
                  "X1","Y1","Z1","E1","p1","T1","type1",
                  "X2","Y2","Z2","E2","p2","T2","type2",
                  "Npart","good","trig1","trig2","trig3","trig4"
                  ,""};


int psim_readfile_init(char *fname);
void psim_readfile_close(void);
int read_event(raw_event_t *re);

void ParseArgs(int narg,char *argv[]);
void Usage(void);
void EHandler(int sig);


/*-------- Declarations to allow linking -------*/
   int nt1=100;
   int debug=0;
/*----------------------------------------------*/

float farray[256];

int main(int narg,char *argv[])
{
   raw_event_t re;
   int i,j,N;
   int Nevents=0,Nevents_written=0;
   time_t last_time=0L;
   part_info_t *p;
   int cut_event;
   float a;
   int good,trig1,trig2,trig3,trig4;
   long total_generated=0,g;
   long last_event=0;
   long Nkept_before_this_file=0,Ngenerated_before_this_file=0;
	long Ntmp,Gtmp,estimated_total_genrated=0;
   char unit;
   
   /*Try and exit gracefully should any errors occur*/
   signal(SIGPIPE,EHandler);
   signal(SIGTERM,EHandler);
   signal(SIGINT,EHandler);
   signal(SIGFPE,EHandler);

   ParseArgs(narg,argv);   
   
   /* loop over input files*/
   for(N=0;N<Ninfiles;N++){
   
      /* open input file */
      psim_readfile_init(infname[N]);

      /* read in events */
      while(read_event(&re)){
         if(quit_program)break;
      
      
         /* Update screen */
         if(time(NULL)!=last_time){
         	g=total_generated;
         	unit=' ';
         	if(g>10000){g/=1000;unit='k';}
         	if(g>10000){g/=1000;unit='M';}
         	
         	printf("  %d  events  (%ld%c generated)  \r"
         		,Nevents
         		,g
         		,unit);
            fflush(stdout);
            last_time=time(NULL);
         }
         Nevents++;

			/* try to estimate true total event generated */
			if(re.event<last_event){
				Ntmp=Nevents-Nkept_before_this_file;
				Gtmp=total_generated-Ngenerated_before_this_file;

				g=(long)((double)Gtmp*(1.0+(1.0/(2.0*(double)Ntmp))));
				estimated_total_genrated+=g;
				
				Nkept_before_this_file=Nevents;
				Ngenerated_before_this_file=total_generated;
			}

			total_generated+=re.event - (re.event>last_event ? last_event:0);
			
			last_event=re.event;
      }
      psim_readfile_close();
      printf("  %d  events  (%ld generated)\n",Nevents,total_generated);
      printf("Close file \"%s\"\n",infname[N]);
      if(quit_program)break;
   }

	/* finish estimating true total number of events generated */
	Ntmp=Nevents-Nkept_before_this_file;
	Gtmp=total_generated-Ngenerated_before_this_file;
	g=(long)((double)Gtmp*(1.0+(1.0/(2.0*(double)Ntmp))));
	estimated_total_genrated+=g;

	/* Print results to screen and exit */
   printf("                             \n\n");
   printf(" %d  events  (%ld generated)\n",Nevents,total_generated);
   printf("Estimated true total generated: %ld\n",estimated_total_genrated);
   printf("done.\n");
   
   return 0;
}


void ParseArgs(int narg,char *argv[])
{
   int i;
   char *ptr;
   
   if(narg<2)Usage();
   
   for(i=1;i<narg;i++){
      if(!strcmp(argv[i],"-h"))Usage();
      if(argv[i][0]!='-')strcpy(infname[Ninfiles++],argv[i]);
   }
   
   if(Ninfiles<1){
      printf("You must provide at least one input filename.\n");
      exit(-1);
   }
}


void Usage(void)
{
   int done=0,i,j;
   
   printf("\nUsage:\n\tpsim_count inputfile1 [inputfile2 ...]\n\n");
   printf("\t\t -h \t\tprint this message\n");
   printf("\n Count the number of events in file(s).\n");


   exit(0);
}

void EHandler(int sig)
{
   quit_program=1;
   printf("\n signal received of type ");
   if(sig==SIGPIPE)printf("SIGPIPE\n");
   if(sig==SIGTERM)printf("SIGTERM\n");
   if(sig==SIGINT)printf("SIGINT\n");
   if(sig==SIGFPE)printf("SIGFPE\n");
}

