

#include "psim_view.h"

#define max_colors 66

char* ShowTrigGroup(ClientData cd,Tcl_Interp *interp,char *n1,char *n2,int flags)
{
   char prefix[32],TAG[32],GTAG[32],TAGS[32];
   char cmd[256];
   int i,j;
   subset *s;
   char colors_t1[100][16]={
      						"#99F","#00F","#99F",
                        "#F00","#F99","#F00",
                        "#99F","#99F",
                        "#F99","#F00",
                        "#99F","#99F",
                        "#F00","#F99","#F00",
      						"#99F","#00F","#99F",
                        "#00F","#99F","#00F","#99F","#00F",
                        "#F00","#F99","#F00","#F99",
                        "#00F","#99F","#00F","#99F","#00F"};

   char colors_t2[100][16]={
      						"#99F","#00F",
                        "#F00","#F99",
      						"#99F","#00F",
                        "#F00","#F99",
                        "#99F",
                        "#F99",
                        "#99F",
                        "#F99",
                        "#99F",
                        "#F99",
                        "#99F","#00F",
                        "#F00","#F99",
      						"#99F","#00F",
                        "#F00","#F99",
                        "#00F","#99F","#00F",
                        "#F00","#F99","#F00",
                        "#00F","#99F","#00F",
                        "#F55","#F00",
                        "#00F","#99F","#00F",
                        "#F00","#F99","#F00"};

   char colors_t3[100][16]={
      						"#F00","#F99","#F00","#F99","#F00","#F99",
      						"#00F","#99F","#00F","#99F","#00F","#99F",
      						"#F00","#F99","#F00","#F99","#F00","#F99",
      						"#00F","#99F","#00F","#99F","#00F","#99F",
      						"#F00","#F99","#F00","#F99","#F00","#F99",
      						"#00F","#99F","#00F","#99F","#00F","#99F",
      						"#0F0","#9F9","#0F0","#9F9","#0F0",
      						"#F0F","#F9F","#F0F","#F9F","#F0F",
      						"#0F0","#9F9","#0F0","#9F9","#0F0",
      						"#F0F","#F9F","#F0F","#F9F","#F0F",
      						"#0F0","#9F9","#0F0","#9F9","#0F0",
      						"#F0F","#F9F","#F0F","#F9F","#F0F"
                        };


   int color=0;
   int insertion;
   int det,x,y;
   char colors[50][16];
   
   
   switch(show_trig_group){
      case 1:
         strcpy(prefix,group_orientation ? "H":"V");
         for(i=0;i<max_colors;i++)strcpy(colors[i],colors_t1[i]);
         break;
      case 2:
         strcpy(prefix,"T2V");
         for(i=0;i<max_colors;i++)strcpy(colors[i],colors_t2[i]);
         break;
      case 3:
         strcpy(prefix,"T3G");
         for(i=0;i<max_colors;i++)strcpy(colors[i],colors_t3[i]);
         break;
      case 4:
         strcpy(prefix,"ALL");
         for(i=0;i<max_colors;i++)strcpy(colors[i],colors_t2[i]);
         break;
      case 5:
         strcpy(prefix,group_orientation ? "H":"V");
         for(i=0;i<max_colors;i++)strcpy(colors[i],colors_t1[i]);
         break;
   }
   
   sprintf(TAG,"%s_tag",prefix);
   
   /* Delete old tag (if any) */
   Tcl_Eval(interp,".c.c delete V_tag T2V_tag T3G_tag ALL_tag ; update");
   
   for(i=0;i<nsets;i++){
      s=sets[i];
      if(strncmp(s->name,prefix,strlen(prefix)))continue;
      
      strcpy(GTAG,s->name);
      sprintf(TAGS,"{%s %s}",TAG,GTAG);  
      
      for(j=0;j<s->Num;j++){
         det=s->list[j]-1;
         if(det<1000){
            x=det%27;
            y=det/27;
            insertion=0;
         }else{
            x=(det-1000)%22;
            y=(det-1000)/22;
            insertion=1;
         }
         
         /* color the cell */
         if(color>=max_colors)color=0;      
         sprintf(cmd,"DrawCell %d %d %s %s %s %d %d"
               ,x ,y ,colors[color], "#000" ,TAGS ,1,insertion);
         Tcl_Eval(interp,cmd);
         
      }
      /* bind a command to update the group energy label with mouseovers */
      sprintf(cmd,".c.c bind %s <Enter> ",GTAG);
      sprintf(cmd,"%s {UpdateGroupEnergy %s",cmd,GTAG);
      /* bind a command to display at 50% with mouseovers */
      sprintf(cmd,"%s ; .c.c itemconfigure %s -stipple gray50 }",cmd,GTAG);
      Tcl_Eval(interp,cmd);
      /* bind a command to display at 12% with mouseleaves */
      sprintf(cmd,".c.c bind %s <Leave> ",GTAG);
      sprintf(cmd,"%s {+.c.c itemconfigure %s -stipple gray12 }",cmd,GTAG);
      Tcl_Eval(interp,cmd);
      color++;
   }
   
   sprintf(cmd,".c.c itemconfigure %s -stipple gray12 ; update",TAG);
   Tcl_Eval(interp,cmd);

   /* Show Appropriate trigger bits */
   Tcl_Eval(interp,
      "pack forget .c.s.tg.tb5yl .c.s.tg.tb5yh .c.s.tg.tb5xl .c.s.tg.tb5xh");
   Tcl_Eval(interp,"pack forget .c.s.tg.tb1y .c.s.tg.tb1x .c.s.tg.go ");
   if(show_trig_group==1){
      Tcl_Eval(interp,"pack .c.s.tg.go .c.s.tg.tb1y .c.s.tg.tb1x -side bottom -fill both");
   }else if(show_trig_group==5){
      Tcl_Eval(interp,
         "pack .c.s.tg.go .c.s.tg.tb5yl .c.s.tg.tb5yh .c.s.tg.tb5xl .c.s.tg.tb5xh -side bottom -fill both");   
   }

   /* Re-display current event */
   READ_EVENT=0;
   Tcl_Eval(interp,"DrawEvent");
   READ_EVENT=1;

   return NULL;
}


int TCL_UpdateGroupEnergy(	 ClientData clientData
   			,Tcl_Interp *interp
            ,int argc,char *argv[])
{
   char cmd[256],str[256];
   int i;
   subset *s;
   
   if(argc<2){
      printf("Tcl_UpdateGroupEnergy called with only %d args\n",argc);
      return TCL_OK;
   }

   s=FindSubset(argv[1]);
   
   /* name */
   sprintf(cmd,".c.s.gi.gn configure -text \"Name: %s\"",s->name);
   Tcl_Eval(interp,cmd);

   /* energy */
   sprintf(cmd,".c.s.gi.ge configure -text \"Energy: %4.3f GeV\"",s->E);
   Tcl_Eval(interp,cmd);

   /* Nmembers */
   sprintf(cmd,".c.s.gi.ne configure -text \"Nelements: %d\"",s->Num);
   Tcl_Eval(interp,cmd);

   /* fill listbox */
   Tcl_Eval(interp,".c.s.gi.lbf.lb delete 0 end");
   for(i=0;i<s->Num;i++){
      sprintf(str,"%3d   %3.3f MeV",s->list[i],re.SHWDET[s->list[i]]*1000.0);
      sprintf(cmd,".c.s.gi.lbf.lb insert end \"%s\"",str);
      Tcl_Eval(interp,cmd);
   }
   Tcl_Eval(interp,"focus .c.s.gi.lbf.sb");
   
   return TCL_OK;
}





